package actions;

import ihm.Gestionnaire;
import java.awt.event.ActionEvent;
import java.util.Vector;
import javax.swing.AbstractButton;

/**  Action appelée pour faire afficher ou non les annotations
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class ActionChangerAnnotations extends ActionGestionnaire
{
	/** collection de boutons */
	private static Vector<AbstractButton> m_boutons;
	
	private Gestionnaire m_gest=getM_gest();

	/** Constructeur
	 * @param gest
	 */
	public ActionChangerAnnotations(Gestionnaire gest)
	{
		super(gest);
		if(m_boutons==null) m_boutons=new Vector<AbstractButton>(); 
	}

	/** Constructeur
	 * @param gest
	 * @param source
	 */
	public ActionChangerAnnotations(Gestionnaire gest, AbstractButton source)
	{
		super(gest);
		if(m_boutons==null) m_boutons=new Vector<AbstractButton>();
		m_boutons.add(source);
	}

	/** action */
	public void actionPerformed(ActionEvent e)
	{
		boolean nouvel_etat=!m_gest.isAnnotationsDonnesEnCours();
		m_gest.setAnnotationsDonnesEnCours(nouvel_etat);
		for (AbstractButton bouton : m_boutons)
			bouton.setSelected(nouvel_etat);
	}
}
