package actions;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import don.DonneeParse;

/** Action appelée pour changer un axe dans la fenétre de choix des axes
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class ActionChangerAxe extends AbstractAction implements ListSelectionListener
{
	private static final long serialVersionUID = 6932619576085566191L;

	/** La liste concernée */
	private JList m_liste;

	/** Le label à mettre à jour pour l'inertie */
	private JLabel m_labelInertie;

	/** Le tableau des inerties des axes */
	private double[] m_inertie;

	/** Constructeur
	 * @param list
	 * @param labelInertie
	 * @param inertie
	 */
	public ActionChangerAxe(JList list, JLabel labelInertie, double[] inertie) {
		m_liste=list;
		m_labelInertie=labelInertie;
		m_inertie=inertie;
	}

	/** action du label inertie */
	public void valueChanged(ListSelectionEvent e)
	{
		int axe = m_liste.getSelectedIndex();
		m_labelInertie.setText(DonneeParse.pourcentage(m_inertie[axe]));		
	}

	/** action */
	public void actionPerformed(ActionEvent arg0)
	{
		int axe = m_liste.getSelectedIndex();
		m_labelInertie.setText(DonneeParse.pourcentage(m_inertie[axe]));
	}
}
