package actions;

import ihm.FenetreChoixAxes;
import ihm.FenetreChoixAxesFactoriels;
import ihm.Gestionnaire;
import ihm.IHM;
import java.awt.event.ActionEvent;


/** Action appelée quand on demande à changer les axes
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class ActionChoixAxes extends ActionGestionnaire
{
	/** L'interface dont va faire partie la fenétre */
	private IHM m_owner;

	/** Le nombre d'axes possibles */
	private int m_nbAxes;

	/** Les inerties de chaque axe */
	private double[] m_inerties;
	
	private Gestionnaire m_gest=getM_gest();

	/** Constructeur
	 * @param ihm
	 * @param nbAxes
	 * @param inerties
	 * @param gest
	 */
	public ActionChoixAxes(IHM ihm, int nbAxes, double[] inerties, Gestionnaire gest)
	{
		super(gest);
		m_nbAxes=nbAxes;
		m_inerties=inerties;
		m_owner=ihm;
	}

	/** mise à jour des parmétres
	 * @param ihm
	 * @param nbAxes
	 * @param inerties
	 */
	public void update(IHM ihm, int nbAxes, double[] inerties)
	{
		m_nbAxes=nbAxes;
		m_inerties=inerties;
		m_owner=ihm;
	}
	
	/** action */
	public void actionPerformed(ActionEvent e)
	{
		if(m_gest.getType()!=Gestionnaire.DATAFRAME)
			new FenetreChoixAxesFactoriels(m_owner, m_inerties, m_nbAxes, m_gest);
		else
			new FenetreChoixAxes(m_owner,m_gest);
	}
}
