package actions;

import ihm.Gestionnaire;
import ihm.IHM;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import org.jfree.ui.ExtensionFileFilter;

import outils.Constantes;

/** Action générale d'ouverture et d'enregistrement
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class ActionEnregOuvrir implements ActionListener
{
	/** le gestionnaire */
	private Gestionnaire m_gest;
	
	/** la fenétre */
	private JFrame m_f;
	
	/** vrai si on enregistre */
	private boolean m_isSave;

	/**
	 * @param m_isSave
	 */
	public void setM_isSave(boolean m_isSave) {
		this.m_isSave = m_isSave;
	}

	/** Constructeur
	 * @param gest
	 */
	public ActionEnregOuvrir(Gestionnaire gest)
	{
		m_f=new JFrame();
		Image icone = Toolkit.getDefaultToolkit().getImage(IHM.m_dir+Constantes.ICONE_FENETRE);
		m_f.setIconImage(icone);
		m_gest=gest;}

	/** action */
	public void actionPerformed(ActionEvent e)
	{
		JFileChooser select=new JFileChooser(System.getProperty("user.dir"));
		ExtensionFileFilter filter = new ExtensionFileFilter(IHM.getXmlLangue().getElement("Files"),".ser");
		select.addChoosableFileFilter(filter);
		int option;
		String texte;
		if(m_isSave)
			texte=IHM.getXmlLangue().getElement("Tenregistrer"); 
		else 
			texte=IHM.getXmlLangue().getElement("Touvrir");
		select.setDialogTitle(texte);
		option=select.showDialog(m_f, texte);

		if (option == JFileChooser.APPROVE_OPTION)
		{
			String filename = select.getSelectedFile().getPath();
			if(m_isSave)
			{
				ExtensionFileFilter ff = ((ExtensionFileFilter)select.getFileFilter());
				String ext=ff.getExtension();
				if (!filename.endsWith(ext))filename = filename + ext;
				m_gest.enregistrer(filename);
			}
			else
				m_gest.ouvrir(filename);
		}
		else m_f.dispose();
	}
}
