package criteres;

import ihm.IHM;
import don.DonneeID;
import don.Groupe;
import don.Individu;
import don.Modalite;
import don.Variable;

/** Test si une donnee est active
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereActif extends Test 
{
	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{return IHM.getXmlLangue().getElement("CactifMF");}

	/**@see criteres.Test#correspond(DonneeID)*/
	public boolean correspond(DonneeID obj)
	{ return obj.isActive();}
	
	/** @see criteres.Critere#qualifier(DonneeID)
	 * @param obj
	 * @return qualifie l'objet (par un texte)
	 */
	public String qualifier(DonneeID obj)
	{
		if(obj  instanceof Individu){
		    if(obj.isActive()) return IHM.getXmlLangue().getElement("CactifM");
		    else return CHAINE_ERREUR+" non actif";
		}else if (obj instanceof Variable) {
		    if(obj.isActive()) return IHM.getXmlLangue().getElement("CactifF");
		    else return CHAINE_ERREUR+" non actif";
		}else if (obj instanceof Groupe) {
		    if(obj.isActive()) return IHM.getXmlLangue().getElement("CactifM");
		    else return CHAINE_ERREUR+" non actif";
		}else if(obj instanceof Modalite) {
		    if(obj.isActive()) return IHM.getXmlLangue().getElement("CactifF");
		    else return CHAINE_ERREUR+" non actif";
		}else return CHAINE_ERREUR+" type inconnu";
	}

	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return true;}	
}
