package criteres;

import ihm.IHM;
import java.util.Vector;
import don.DonneeID;

/** Crit�re qui teste l'appartenance d'un objet à un ensemble
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereAppartient extends Test
{
	/** Collection de DonneeID */
	private Vector<DonneeID> m_ensemble;

	/** nom de la collection */
	private String m_nom;

	/** Constructeur
	 * @param vect l'ensemble de test
	 * @param nom le nom de l'ensemble (pour la s�mantique)
	 * 
	 */
	public CritereAppartient(Vector<DonneeID> vect, String nom)
	{
		m_ensemble=new Vector<DonneeID>(vect);
		m_nom=nom;
	}

	/** Constructeur qui ne donne pas de nom à l'ensemble,
	 * la s�mantique rend alors une chaine vide
	 * 
	 * @param vect l'ensemble de test
	 */
	public CritereAppartient(Vector<? extends DonneeID> vect)
	{
		m_ensemble=new Vector<DonneeID>(vect);
		m_nom=null;
	}

	/**@see criteres.Test#adjectif()*/
	public boolean adjectif()
	{return true;}

	/**@see criteres.Test#correspond(don.DonneeID)*/
	public boolean correspond(DonneeID obj)
	{return m_ensemble.contains(obj);}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{
		if(m_nom!=null)
			return IHM.getXmlLangue().getElement("Cappartient")+" "+m_nom;
		else
			return "";
	}
}
