package criteres;

import ihm.IHM;
import don.DonneeID;
import don.Partitionnable;

/** Classifie selon la génération
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereGeneration extends Qualificatif
{
	/**@see criteres.Critere#evaluer(DonneeID)*/
	public Info evaluer(DonneeID obj)
	{
		if(obj instanceof Partitionnable)
		{
			int gen=((Partitionnable)obj).getGeneration();
			if(gen > 0) return new Singleton(gen);
			else return new Singleton(CODE_ERROR);
		}else return new Singleton(CODE_ERROR);
	}

	/**@see criteres.Critere#semantique(Singleton)*/
	public String semantique(Singleton i)
	{return IHM.getXmlLangue().getElement("Cgeneration")+" "+i.get();}

	/**@see criteres.Critere#getNbSeries()*/
	public int getNbSeries()
	{
	    return 10;//TODO trouver une solution viable (en calculant le plus profond ?)
	}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{return IHM.getXmlLangue().getElement("CdonneePartielle");}

	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return true;}
}
