package criteres;

import java.util.Vector;
import ihm.IHM;
import don.ContinueAnalysee;
import don.DonneeID;
import don.Groupe;

/** Critere qui habille les continues par groupe
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereHabGroupeContinue extends Qualificatif
{
	/** Collection de Groupe */
	private Vector<Groupe> m_groupe;

	/** Constructeur */
	public CritereHabGroupeContinue()
	{m_groupe=new Vector<Groupe>();}

	/**@see criteres.Critere#evaluer(DonneeID)*/
	public Info evaluer(DonneeID obj)
	{
		if(!(obj instanceof ContinueAnalysee)) return new Singleton(CODE_ERROR);
		else{
			for (Groupe gr : m_groupe)
			{
				if(gr.getNum()==obj.getGr().getNum())
					return new Singleton(gr.getNum());
			}
			m_groupe.add(obj.getGr());
			return new Singleton(obj.getGr().getNum());
		}
	}

	/**@see criteres.Critere#getNbSeries()*/
	public int getNbSeries()
	{return m_groupe.size();}

	/**@see criteres.Critere#semantique(Singleton)*/
	public String semantique(Singleton s)
	{
		int i=0;
		while(i<m_groupe.size() && m_groupe.get(i).getNum()!=s.get())i++;
		if(i<m_groupe.size() && m_groupe.get(i).getNum()==s.get())return IHM.getXmlLangue().getElement("CHabGroupe") + " "+ m_groupe.get(i).getAnnotation();
		else return CHAINE_ERREUR;
	}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{return IHM.getXmlLangue().getElement("CHabGroupe");}

	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return false;}
}
