package criteres;

import ihm.IHM;
import don.DonneeID;
import don.Modalite;
import don.Nominale;

/** teste si l'objet est un modalite d'une nominale particulière
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereModNominale extends Test
{
	/** la Nominale */
	private Nominale m_nom;
	
	/** Constructeur
	 * @param nom
	 */
	public CritereModNominale(Nominale nom)
	{m_nom=nom;}

	/**@see criteres.Test#evaluer(DonneeID)*/
	public Info evaluer(DonneeID obj)
	{
		if(obj instanceof Modalite)
		{
			if(((Modalite)obj).getNominale().equals(m_nom)) return new Singleton(CODE_OK);
			else return new Singleton(CODE_ERROR);
		}
		else return new Singleton(CODE_ERROR);
	}

	/**@see criteres.Test#correspond(DonneeID)*/
	public boolean correspond(DonneeID obj)
	{
	    if(obj instanceof Modalite)
	    	return(((Modalite)obj).getNominale().equals(m_nom));
	    else return false;
	}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{return IHM.getXmlLangue().getElement("CmodaliteDe")+" "+m_nom.getAnnotation();}

	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return false;}

	/**
	 * @return the m_nom
	 */
	public Nominale getNom() {
		return m_nom;
	}
}
