package criteres;

import ihm.IHM;
import don.DonneeID;
import don.Nominale;

/** Qualifie un individu selon une nominale
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereNominale extends Qualificatif
{
	/** la Nominale */
	private Nominale m_nominale;
	
	/** Constructeur
	 * @param nominale
	 */
	public CritereNominale(Nominale nominale)
	{m_nominale=nominale;}
	
	/**@see criteres.Critere#evaluer(DonneeID)*/
	public Info evaluer(DonneeID obj)
	{
		int num = m_nominale.getNumModalite(obj);
		if(num!=-1){
			return new Singleton(num);
		}else
			return new Singleton(Critere.CODE_ERROR);		
	}

	/**@see criteres.Critere#semantique(Singleton)*/
	public String semantique(Singleton i)
	{
	    if(i.get() < m_nominale.getNbModalites() && !i.isError())return m_nominale.getModalites().elementAt(i.get()).getAnnotation();
	    else return "";
	}

	/**@see criteres.Critere#getNbSeries()*/
	public int getNbSeries()
	{return m_nominale.getNbModalites();}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{return IHM.getXmlLangue().getElement("Cnominale")+" "+m_nominale.getAnnotation();}

	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return false;}
}
