package criteres;

import ihm.Habilleur;
import ihm.IHM;
import don.Continue;
import don.DonneeID;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class CriterePositifNegatif extends Qualificatif {


	private static final int NEGATIF = -1;
	private static final int POSITIF = +1;
	private Habilleur m_habilleur;

	/**
	 * @param habilleur
	 */
	public CriterePositifNegatif(Habilleur habilleur) {
		m_habilleur=habilleur;
	}


	@Override
	public boolean adjectif() {
		return true;
	}


	@Override
	public Info evaluer(DonneeID obj) {
		Continue habillage=m_habilleur.getHabillageContinu(obj);
		if(habillage==null){
			return new Singleton(CODE_OK);
		}else{
			if(habillage.getValeur(obj)>0){
				return new Singleton(POSITIF);
			}else{
				return new Singleton(NEGATIF);
			}
		}
	}

	@Override
	public int getNbSeries() {
		return 3;
	}


	@Override
	public String semantique() {
		return "";
	}


	@Override
	public String semantique(Singleton i) {
		if(i.get()==POSITIF){
			return "";
		}else if(i.get()==NEGATIF){
			return IHM.getXmlLangue().getElement("CNegatif");
		}else{
			return "";
		}
	}

}
