package criteres;

import ihm.Habilleur;
import don.DonneeID;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class CritereSeuilAffinage  extends Qualificatif {

	private static final int EN_DESSOUS = -1;
	private static final int AU_DESSUS = +1;
	private Habilleur m_habilleur;

	/**
	 * @param habilleur
	 */
	public CritereSeuilAffinage(Habilleur habilleur) {
		m_habilleur=habilleur;
	}

	@Override
	public boolean adjectif() {
		return true;
	}

	@Override
	public Info evaluer(DonneeID obj) {
		if(m_habilleur.isSousSeuilAffinage(obj)){
			return new Singleton(EN_DESSOUS);
		}else{
			return new Singleton(AU_DESSUS);
		}
	}


	@Override
	public int getNbSeries() {
		return 2;
	}


	@Override
	public String semantique() {
		return "";
	}


	@Override
	public String semantique(Singleton i) {
		if(i.get()==AU_DESSUS){
			return "  ";
		}else if(i.get()==EN_DESSOUS){
			return " ";
		}else{
			return "";
		}
	}



}
