package criteres;

import ihm.IHM;
import don.DonneeID;
import don.ContinueAnalysee;

/** Teste si l'objet est une variable continue
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class CritereVariableContinue extends Test
{
	private String semantique=null;

	/**
	 * @param semantique_forcee une sémantique forcée (utile par exemple pour les axes partiels)
	 */
	public CritereVariableContinue(String semantique_forcee) {
		semantique=semantique_forcee;
	}

	/**
	 * 
	 */
	public CritereVariableContinue() {
		super();
		semantique=IHM.getXmlLangue().getElement("Ccontinue");
	}

	/**@see criteres.Test#correspond(DonneeID)*/
	public boolean correspond(DonneeID obj)
	{return obj instanceof ContinueAnalysee;}

	/**@see criteres.Critere#semantique()*/
	public String semantique()
	{
			return semantique;		
	}



	/**@see criteres.Critere#adjectif()*/
	public boolean adjectif()
	{return false;}
}
