package criteres;

/** Classe d'information multiple
 * 	repose sur une logique d'arbre
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Paire extends Info
{
	/** Info de gauche */
	private Info _g;

	/** Info de droite */
	private Info _d;

	/** Constructeur
	 * @param g
	 * @param d
	 */
	public Paire(int g, int d)
	{
		_g =new Singleton(g);
		_d=new Singleton(1);	
	}

	/** Constructeur
	 * @param g
	 * @param d
	 */
	public Paire(int g, Info d)
	{
		_g=new Singleton(g);
		_d=d;
	}

	/** Constructeur
	 * @param val1
	 * @param val2
	 */
	public Paire(Info val1, Info val2)
	{
		_g=val1;
		_d=val2;
	}

	/** @return l'info de droite */
	public Info getD()
	{return _d;} 

	/** @return l'info de gauche */
	public Info getG()
	{return _g;}

	/**@see criteres.Info#suite()*/
	public boolean suite()
	{return true;}

	/**@see criteres.Info#toString()*/
	public String toString()
	{return "( "+_g.toString()+", "+_d+" )";}

	/**@see criteres.Info#isError()*/
	public boolean isError()
	{return _g.isError() && _d.isError();}

	@Override
	public boolean equals(Object o) {
		if(o instanceof Paire)
			return _g.equals(((Paire)o).getG()) && _d.equals(((Paire)o).getD()); 
		else
			return false;
	}
}
