package criteres;

import don.DonneeID;

/** Test la DonneeID
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public abstract class Test extends Critere
{
	/**@see criteres.Critere#getNbSeries()*/
	public int getNbSeries()
	{return 1;}

	/**@see criteres.Critere#evaluer(don.DonneeID)*/
	public Info evaluer(DonneeID obj)
	{
		if (correspond(obj)) return new Singleton(CODE_OK);
		else return new Singleton(CODE_ERROR);
	}

	/** Applique le test à un objet
	 * @param obj
	 * @return true si l'objet correspond au test, false sinon
	 */
	public abstract boolean correspond(DonneeID obj);

	/**@see criteres.Critere#semantique(Singleton)*/
	public String semantique(Singleton i)
	{
		if(i.get()==CODE_ERROR)return "";
		else return semantique();
	}

	/**@see criteres.Critere#adjectif()*/
	public abstract boolean adjectif();
	
}
