package don;

import java.util.Vector;

/**
 * Variable à valeurs continues
 * 
 *  @author julien.durand@gmail.com *
 */
public interface Continue extends Variable{
	
		
	/**
	 * @param donneeID
	 * @return la valeur de la variable pour cette donnée
	 */
	public double getValeur(DonneeID donneeID);

// version 1.05
	/**
	 * @param donneeID
	 * @param t
	 * @return la valeur de la variable pour cette donnée
	 */
	public double getValeur(DonneeID donneeID, DonneeParse.TypeAnalyse t);
// fin version 1.05
	/**
	 * @param donnees
	 * @return l'amplitude des valeurs de la variable pour ce jeu de données
	 */
	public double getAmplitude(Vector<? extends DonneeID> donnees);

	/**
	 * @param donnees
	 * @return le minimum des valeurs de la variable pour ce jeu de données
	 */
	public double getMin(Vector<? extends DonneeID> donnees);

	/**
	 * @param donnees
	 * @return la valeur absolue max des valeurs de la variable pour ce jeu de données
	 */
	public Double getValeurAbsolueMax(Vector<? extends DonneeID> donnees);
}
