package don;

import java.io.Serializable;
import java.util.Vector;


/**
 * Représente les continues artificielles utilisées pour l'habillage (cos², contrib, etc..)
 * 
 *  @author julien.durand@gmail.com
 */
public abstract class ContinueArtificielle implements Continue,  Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * @param vect le jeu de données
	 * @return le minimum de la continue sur le jeu de données
	 */
	public double getMin(Vector<? extends DonneeID> vect) {
		double min=Double.MAX_VALUE;
		for(int i=0;i<vect.size();i++) {
			double res=getValeur(vect.get(i));
			if(res<min)min=res;
		}
		return min;
	}

	/**
	 * @param vect le jeu de données
	 * @return le maximum de la continue sur le jeu de données
	 */
	public double getMax(Vector<? extends DonneeID> vect)
	{
		double max=Double.MIN_VALUE;
		for(int i=0;i<vect.size();i++) {
			double res=getValeur(vect.get(i));
			if(res>max)max=res;
		} 
		return max;    
	}


	/**
	 * @param vect
	 * @return l'amplitude de la variable
	 */
	public double getAmplitude(Vector<? extends DonneeID> vect) {
		return getMax(vect)-getMin(vect);
	}
	
	public Double getValeurAbsolueMax(Vector<? extends DonneeID> donnees) {		
		return Math.max(getMax(donnees), -getMin(donnees));
	}
}
