package don;

/**
 * Pseudo-variable (variable artificielle) capable de donner une valeur à une donnée 
 * qui va dépendre des axes utilisés pour la représentation
 * 
 * exemple : cos² ou contribution
 * 
 *  @author julien.durand@gmail.com
 * 
 */
public abstract class ContinueArtificielleSurAxes extends ContinueArtificielle {
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/** le numéro du premier axe concerné*/
	protected Dimension m_axe1;
	/** le numéro du second axe concerné*/
	protected Dimension m_axe2;
	
	/**    
	 */
	public ContinueArtificielleSurAxes() {
	}
	
	
	/**
	 * @param axe1 le premier axe a prendre en compte 
	 * @param axe2 le second axe a prendre en compte       
	 */
	public ContinueArtificielleSurAxes(Dimension axe1, Dimension axe2) {
		m_axe1=axe1;
		m_axe2=axe2;
	}
	
	/**
	 * met à jour les axes à prendre en compte par la pseudo-variable
	 * 
	 * @param axe1 le premier axe a prendre en compte 
	 * @param axe2 le second axe a prendre en compte    
	 */
	public void updateAxes(Dimension axe1, Dimension axe2){
		m_axe1=axe1;
		m_axe2=axe2;
	}
	
	/**
	 * met à jour les axes à prendre en compte par la pseudo-variable
	 * 
	 * @param axe1 le premier axe a prendre en compte 
	 */
	public void updateAxeX(Dimension axe1){
		m_axe1=axe1;
	}
	
	/**
	 * met à jour les axes à prendre en compte par la pseudo-variable
	 * 
	 * @param axe2 le premier axe a prendre en compte 
	 */
	public void updateAxeY(Dimension axe2){
		m_axe2=axe2;
	}
	
}
