package don;

import java.util.Vector;

import don.DonneeParse.TypeAnalyse;


/**
 * Pseudo-variable capable de donner la valeur de la contribution 
 * d'un individu sur une representation
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Contribution extends ContinueArtificielleSurAxes 
implements ContinueArtificiellePourMod, ContinueArtificiellePourIndiv, ContinueArtificiellePourCont
{
	private static final long serialVersionUID = 8559287919008658372L;

	/**
	 * @param axe1 le premier axe a prendre en compte 
	 * @param axe2 le second axe a prendre en compte     
	 */
	public Contribution(Dimension axe1, Dimension axe2)
	{
		super(axe1, axe2);
	}


	protected double evaluer(DonneeID don)
	{
		if(don.isActive())
			return don.getContrib(m_axe1.getNum())+don.getContrib(m_axe2.getNum());
		else 
			return 0.001;
	}

	public double getValeur(DonneeID don){
		return evaluer(don);
	}
	
	@Override
	public double getValeur(DonneeID donneeID, TypeAnalyse t) {
		// TODO Auto-generated method stub
		return getValeur(donneeID);
	}

	public double getValeur(Modalite mod) {
		return evaluer(mod);
	}

	public double getValeur(Individu ind) {
		return evaluer(ind);
	}


	public double getValeur(ContinueAnalysee cont) {
		return evaluer(cont);
	}
	
	@Override
	public double getValeur(ContinueAnalysee mod, TypeAnalyse type) {
		// TODO Auto-generated method stub
		return getValeur(mod);
	}


	public String getAnnotation() {
		//TODO String à externaliser
		return "Contribution";
	}
	
	@Override
	public double getMin(Vector<? extends DonneeID> vect) {
		return 0.00000001;
	}


	





}
