package don;

import java.util.Vector;


/**
 * Pseudo-variable capable de donner la valeur du cos� 
 * d'un individu sur une repr�sentation
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Cos2 extends ContinueArtificielleSurAxes 
implements ContinueArtificiellePourMod, ContinueArtificiellePourIndiv, ContinueArtificiellePourCont
{
	private static final long serialVersionUID = 8559287919008658372L;
	
	/**
	 * @param axe1 le premier axe a prendre en compte 
	 * @param axe2 le second axe a prendre en compte       
	 */
	public Cos2(Dimension axe1, Dimension axe2) {
		super(axe1, axe2);
	}


	public double getValeur(Individu ind)
	{return evaluer(ind);}


	public double getValeur(Modalite mod) {		
		return evaluer(mod);
	}
	
	public double getValeur(DonneeID don){
		return evaluer(don);
	}

// version 1.05_reverse	
	public double getValeur(ContinueAnalysee mod, DonneeParse.TypeAnalyse type)
    {
        return evaluer(mod, type);
    }

// version 1.05_reverse	
    public double getValeur(DonneeID donneeID, DonneeParse.TypeAnalyse t)
    {
        return evaluer(donneeID, t);
    }


// version 1.05_light	
//	protected double evaluer(DonneeID don){
//		if(don instanceof ContinueMoyenne){
//			return Math.pow(don.getCoord(m_axe1.getNum()),2.0)+Math.pow(don.getCoord(m_axe2.getNum()),2.0);
//		}else{
//			return don.getCos2(m_axe1.getNum())+don.getCos2(m_axe2.getNum());
//		}
//	}
// fin version 1.05_light

// version 1.05_reverse
	protected double evaluer(DonneeID don)
    {
        return don.getCos2(m_axe1.getNum()) + don.getCos2(m_axe2.getNum());
    }
// version 1.05_reverse	
	protected double evaluer(DonneeID don, DonneeParse.TypeAnalyse t)
    {
        return don.getCos2(m_axe1.getNum()) + don.getCos2(m_axe2.getNum());
    }


	public double getValeur(ContinueAnalysee cont) {
		return evaluer(cont);
	}


	public String getAnnotation() {
		//TODO String à externaliser
		return "Cos²";
	}
	
	@Override
	public double getMin(Vector<? extends DonneeID> vect) {
		return 0.00000001;
	}
	
	@Override
	public double getMax(Vector<? extends DonneeID> vect) {
		return 1;
	}
	

}
