package don;

import ihm.IHM;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class Dimension extends AxePartiel {


	private static final long serialVersionUID = 2340463045755215237L;
	
	private int m_num;

	/**
	 * @param num le numéro de la dimension (>0)
	 */
	public Dimension(int num) {
		this(num, Groupe.getGroupe0());
	}
	
	protected Dimension(int num, Groupe g) {
		super(IHM.getXmlLangue().getElement("LDimension")+num, true, g, null, null, null, true);
		m_num=num-1;
	}
	
	public int getNum(){
		return m_num;
	}
	
	@Override
	public double getValeur(DonneeID donneeID) {
		return donneeID.getCoord(m_num);
	}
	
	@Override
	public double getValeur(Individu ind) {
		return ind.getCoord(m_num);
	}

	@Override
	public double getCoord(int num) {
		if(num==m_num)
			return 1;
		else return 0;
	}

	@Override
	public double getCos2(int num) {
		if(num==m_num)
			return 1;
		else return 0;
	}


	@Override
	public double getContrib(int num) {
		if(num==m_num)
			return 100;
		else return 0;
	}
	
	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		String chaine="---\naxe : "+m_num;
		chaine+=super.toString();
		return chaine;
	}

}
