package don;

import java.awt.Color;
import java.util.Vector;

/**
 * decrit des groupes de variables
 * 
 * @author michaelory@gmail.com
 * @author julien.durand.eu@gmail.com
 */
public class Groupe extends DonneeID
{
	private static final long serialVersionUID = -1786448690184371296L;
	
	private static Groupe m_groupe0;

	/** Le numero du groupe	 */
	private int m_num;

	/** La couleur associee au groupe */
	private Color m_couleur;
	
	/** liste des donnees du groupes */
	private Vector<DonneeID> m_donneesID;
	
	/** 
	 * @return le numero du groupe
	 */
	public int getNum() {
		return m_num;
	}

	/** getteur Couleur Groupe 
	 * @return la couleur du groupe
	 */
	public Color getCouleur() {
		return m_couleur;
	}

	/**
	 * setteur Couleur Groupe
	 * 
	 * @param couleur
	 *            (les annotations peuvent être coloriées en fonction de cette
	 *            couleur)
	 */
	public void setCouleur(Color couleur) {
		m_couleur = couleur;
	}


	/**
	 * @param annotation
	 * @param active
	 * @param coord
	 * @param cos2
	 * @param contrib
	 * @param num
	 * @param couleur
	 */
	public Groupe(String annotation, boolean active, double[] coord,
			double[] cos2, double[] contrib, int num, Color couleur) {
		super(annotation, active, null, coord, cos2, contrib);
		m_num = num;
		m_couleur = couleur;
		m_donneesID=new Vector<DonneeID>();
		if(m_num==0 && m_groupe0!=null)m_groupe0=this;
	}

	/**
	 * Constructeur
	 * @param i le numero du groupe
	 */
	public Groupe(int i) {
		super("Groupe "+i,false,null,null,null,null);
		m_num = i;
		m_couleur = null;
		m_donneesID=new Vector<DonneeID>();
		if(m_num==0 && m_groupe0!=null)m_groupe0=this;		
	}

	/**
	 * @return the m_donneesID
	 */
	public Vector<DonneeID> getDonneesID() {
		return m_donneesID;
	}

	/**
	 * @param obj the m_donneesID to add
	 */
	public void addDonneesID(DonneeID obj) {
		m_donneesID.add(obj);
	}
	
	/**
	 * @see don.DonneeID#toString()
	 */
	public String toString() {
	    String chaine = "Groupe "+m_num+"("+getAnnotation()+"), actif : "+isActive();
	    chaine+=", donnee concernees : ";
	    if(m_donneesID.size()==0)chaine+="aucune";
	    for (DonneeID don : m_donneesID) {
		chaine+=" "+don.getAnnotation()+",";
	    }
	    return chaine;
	}
	
	/**
	 * @return le groupe 0
	 */
	public static Groupe getGroupe0(){
		if(m_groupe0==null){
			new Groupe(0);
		}
		return m_groupe0;
	}
	
}
