package don;

import ihm.IHM;

/**
 * Nominale artificielle qui découpe les données selon leur groupe
 * 
 *  @author julien.durand@gmail.com *
 */
public class NominaleArtificielleGroupe extends Nominale {

	private static final long serialVersionUID = -4601441942982325112L;
	
	private int m_taille;

	/**
	 * @param taille
	 */
	public NominaleArtificielleGroupe(int taille) {
		super(IHM.getXmlLangue().getElement("Cgroupe"));
		m_taille = taille;
	}

	@Override
	public int getNumModalite(DonneeID don){
		return don.getGr().getNum();		
	}
	
	/** 
	 * @return le nombre de modalités de la nominale
	 */
	public int getNbModalites() {
		return m_taille;
	}

}
