package don;

import java.util.Vector;

/**
 * Jeu de donnees vide
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class NullDonneeParse extends DonneeParse
{
    private static final long serialVersionUID = 7677196853275737851L;  
    
    /**
     * Constructeur
     */
    public NullDonneeParse(){super(null, 0);}

    /**
     * @see don.DonneeParse#getColName()
     */
    public String[] getColName(){return new String[0];}

    /**
     * @see don.DonneeParse#getDebutNomsVariables()
     */
    public int getDebutNomsVariables(){return 0;}

    /**
     * @see don.DonneeParse#getGroupe(int)
     */
    public Groupe getGroupe(int i){return null;}

    /**
     * @see don.DonneeParse#getGroupes()
     */
    public Vector<Groupe> getGroupes(){return new Vector<Groupe>();}

    /**
     * @see don.DonneeParse#getIndividu(java.lang.String)
     */
    public Individu getIndividu(String annot){return null;}

    /**
     * @see don.DonneeParse#getIndividusMoyens()
     */
    public Vector<IndividuMoyen> getIndividusMoyens(){return new Vector<IndividuMoyen>();}

    /**
     * @see don.DonneeParse#getInerties()
     */
    public double[] getInerties() {return new double[0];}

    /**
     * @see don.DonneeParse#getModalite(java.lang.String)
     */
    public Modalite getModalite(String annot){return null;}

    /**
     * @see don.DonneeParse#getNbAxe()
     */
    public int getNbAxe(){return 0;}

    /**
     * @see don.DonneeParse#getNbIndividu()
     */
    public int getNbIndividu(){return 0;}

    /**
     * @see don.DonneeParse#getNbVar()
     */
    public int getNbVar(){return 0;}

    /**
     * @see don.DonneeParse#getNominale(int)
     */
    public Nominale getNominale(int i) throws Exception {return null;}

    /**
     * @see don.DonneeParse#getNominale(java.lang.String)
     */
    public Nominale getNominale(String annotation){return null;}

    /**
     * @see don.DonneeParse#getNominales()
     */
    public Vector<Nominale> getNominales(){return new Vector<Nominale>(); }

    /**
     * @see don.DonneeParse#getNumVariable(java.lang.String)
     */
    public int getNumVariable(String annot){return 0;}

    /**
     * @see don.DonneeParse#getVariablesMoyennes()
     */
    public Vector<ContinueMoyenne> getVariablesMoyennes(){return new Vector<ContinueMoyenne>();}

    /**
     * @see don.DonneeParse#isGroupeActif()
     */
    public boolean isGroupeActif(){return false;}

    /**
     * @see don.DonneeParse#isGroupeIllus()
     */
    public boolean isGroupeIllus() {return false;}

    /**
     * @see don.DonneeParse#isIndActif()
     */
    public boolean isIndActif(){return false;}

    /**
     * @see don.DonneeParse#isIndIllus()
     */
    public boolean isIndIllus(){return false;}

    /**
     * @see don.DonneeParse#isIndPart()
     */
    public boolean isIndPart(){return false;}

    /**
     * @see don.DonneeParse#isModActif()
     */
    public boolean isModActif(){return false;}

    /**
     * @see don.DonneeParse#isModIllus()
     */
    public boolean isModIllus(){return false;}

    /**
     * @see don.DonneeParse#isVarActifNonOrtho()
     */
    public boolean isVarActifNonOrtho(){return false;}

    /**
     * @see don.DonneeParse#isVarActifOrtho()
     */
    public boolean isVarActifOrtho(){return false;}

    /**
     * @see don.DonneeParse#isVarIllusNonOrtho()
     */
    public boolean isVarIllusNonOrtho(){return false;}

    /**
     * @see don.DonneeParse#isVarIllusOrtho()
     */
    public boolean isVarIllusOrtho(){return false;}

    /**
     * @see don.DonneeParse#isVarPart()
     */
    public boolean isVarPart(){return false;}
}
