package don;

/**
 * décrit les points qui peuvent avoir des représentations partielles ("araignées")
 * 
 * @author michaelory@gmail.com
 * @author julien.durand.eu@gmail.com
 */
public abstract class Partitionnable extends DonneeID
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * La génération (profondeur dans l'arbre de partition) de cet élément
	 */
	private int m_generation;

	/**
	 * @param annotation
	 * @param active
	 * @param gr
	 * @param coord
	 * @param cos2
	 * @param contrib
	 * @param generation
	 */
	public Partitionnable(String annotation, boolean active, Groupe gr,
			double[] coord, double[] cos2, double[] contrib, int generation) {
		super(annotation, active, gr, coord, cos2, contrib);
		m_generation = generation;
	}

	/**
	 * @return the m_generation
	 */
	public int getGeneration() {
		return m_generation;
	}

	/**
	 * @param generation
	 *            the m_generation to set
	 */
	public void setGeneration(int generation) {
		m_generation = generation;
	}

    

	@Override
	public String toString() {
		return super.toString()+" generation : "+m_generation;
	}

}
