package don;

import java.util.HashMap;

/**
 *  @author julien.durand@gmail.com
 *
 */
public abstract class QualifiableRepresentable extends Partitionnable implements Qualifiable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/** le tableau des modalités*/
	private HashMap<Modalite,Double> val_descMod;
	
	/** le tableau des  continues**/
	private HashMap<ContinueAnalysee,Double> val_descCont;
	
	/** le tableau des nominales **/
	private HashMap<Nominale,Double> val_descNom;

	/**
	 * @param annotation
	 * @param active
	 * @param gr
	 * @param coord
	 * @param cos2
	 * @param contrib
	 * @param generation
	 */
	public QualifiableRepresentable(String annotation, boolean active,
			Groupe gr, double[] coord, double[] cos2, double[] contrib,
			int generation) {
		super(annotation, active, gr, coord, cos2, contrib, generation);
		val_descMod=new HashMap<Modalite,Double>();
		val_descCont=new HashMap<ContinueAnalysee, Double>();
		val_descNom=new HashMap<Nominale, Double>();
	}

	

	public double getDescMod(Modalite mod){
		Double val = val_descMod.get(mod);
		if(val==null)return 0;
		else return val;
	}

	
	public void setDescMod(Modalite mod, Double vtest) {
		val_descMod.put(mod, vtest);
	}

	
	public double getDescCont(ContinueAnalysee cont){
		Double val =  val_descCont.get(cont);
		if(val==null)return 0;
		else return val;
	}

	public void setDescCont(ContinueAnalysee cont, Double vtest) {
		val_descCont.put(cont, vtest);
	}
	
	public double getDescNom(Nominale nom){
		Double val =  val_descNom.get(nom);
		if(val==null)return 0;
		else return val;
	}

	public void setDescNom(Nominale nom, Double vtest) {
		val_descNom.put(nom, vtest);
	}
	
	public double getDesc(DonneeID don){
		if(don instanceof Modalite){
			return getDescMod((Modalite)don);
		}else if(don instanceof ContinueAnalysee){
			return getDescCont((ContinueAnalysee)don);
		}else return 0;
	}
	
	public double getDesc(Nominale don){
		return getDescNom(don);
	}

	public String toString() {
		String chaine=super.toString()+"\n v-tests pour les modalites :\n";
		for (QualifiableRepresentable mod : val_descMod.keySet()) {
			chaine+=mod.getAnnotation()+" : "+val_descMod.get(mod)+" | ";
		}
		chaine+="\n v-tests pour les continues :\n";
		for (Continue cont : val_descCont.keySet()) {
			chaine+=cont.getAnnotation()+" : "+val_descCont.get(cont)+" | ";
		}
		chaine+="\n v-tests pour les nominales :\n";
		for (Nominale nom : val_descNom.keySet()) {
			chaine+=nom.getAnnotation()+" : "+val_descNom.get(nom)+" | ";
		}
		return chaine;
	}
}
