package don;

import java.io.Serializable;

import don.DonneeParse.TypeAnalyse;

import outils.Constantes;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class ValeurTest extends ContinueArtificielle implements Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	Qualifiable m_qualif;

	/**
	 * @param qualif
	 */
	public ValeurTest(Qualifiable qualif) {
		m_qualif=qualif;
	}

	public double getValeur(DonneeID donneeID) {
		if(m_qualif.equals(donneeID)){
			return 2.0;
		}else{
			double desc = m_qualif.getDesc(donneeID);
			if(Math.abs(desc)>Constantes.SEUIL_VTEST_0){
				return desc;
			}else{
				return 0;
			}
		}
	}

	public String getAnnotation() {
		return "valeurs-test pour la description d'une variable ou d'une modalité";
	}

	@Override
	public double getValeur(DonneeID donneeID, TypeAnalyse t) {
		// TODO Auto-generated method stub
		return getValeur(donneeID);
	}

}
