package drawing;

import java.awt.Color;
import java.awt.Paint;
import java.util.Random;
import org.jfree.chart.ChartColor;

/**
 * Classe capable de fournir des couleurs aleatoires
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Couleur
{
	/**
	 * le tableau des couleurs disponibles
	 */
	private Paint[] m_c;
	
	/**
	 * Constructeur
	 */
	public Couleur()
	{
		new Random();
		m_c=ChartColor.createDefaultPaintArray();
	}
	
	/**
	 * @param index
	 * @return une couleur : la couleur de l'index si il ne sort pas du tableau, 
	 * une couleur aléatoire sinon
	 */
	public Color getColor(int index)
	{
		return (Color)m_c[index%m_c.length];
	}
}
