package drawing;

import java.io.Serializable;
import don.DonneeParse;

/**
 * Classe qui contient toutes les informations dont on a besoin
 * pour ouvrir un fichier de graphe 
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Registre implements Serializable
{
	private static final long serialVersionUID = -3184720514177768319L;
	
	/**
	 * le jeu de données
	 */
	private DonneeParse m_don;
	
	/**
	 * l'ensemble des informations de configuration de l'affichage
	 */
	private ConfAffichage m_aff;
	
	/**
	 * Constructeur
	 * @param don : le jeu de donn�es
	 * @param aff : les paramètres d'affichage
	 */
	public Registre(DonneeParse don,ConfAffichage aff)
	{m_don=don;m_aff=aff;}
	
	/**
	 * Constructeur sans param�tres d'affichage
	 * @param don
	 */
	public Registre(DonneeParse don){this(don,null);}

	/**
	 * @return les données
	 */
	public DonneeParse getDonnee(){return m_don;}
	
	/**
	 * @return la configuration graphique
	 */
	public ConfAffichage getConfAffichage(){return m_aff;}
}
