package drawing;

import java.util.Vector;
import don.DonneeID;

/**
 * stocke les annotations sélectionnées
 * 
 *  @author michaelory@gmail.com
 *
 */
public class SelectZone
{
    /**
     * la liste des donnees concernees
     */
    private Vector<DonneeID> m_select;

    /**
     * constructeur      
     * @param collection d'XYIDAnnotation
     */
    public SelectZone(Vector<DonneeID> collection) {
	m_select = collection;
    }

    /**
     * ajout d'une annotation dans la collection     
     * @param objet DonneeID
     */
    public void addSelect(DonneeID objet) {
	m_select.add(objet);
    }

    /**      
     * @param i emplacement de l'objet
     * @return la DonneeID de située à l'index i
     */
    public DonneeID getSelect(int i) {
	return m_select.get(i);
    }

    /**
     * @return les donnees
     */
    public Vector<DonneeID> getSelect(){return m_select;}

    /**  
     * @return la taille de la collection de sélection
     */
    public int tailleSelect() {
	return m_select.size();
    }
}
