package dyn;

import ihm.Gestionnaire;
import ihm.Habilleur;

import java.util.Iterator;
import java.util.Vector;
import org.jfree.data.xy.DefaultXYDataset;
import org.jfree.data.xy.XYDataset;

import don.DonneeMoyenne;
import drawing.Series;

/** Classe qui correspond à un nuage de points avec points partiels ("araignées")
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Araignee extends NuagePointHabille
{
	/** Constructeur 
	 * @param gest : le Gestionnaire qui commande le graphe 
	 * @param hab 
	 * @param titreGraphe : le titre du graphe 
	 * @param titreX : le titre de l'axe X 
	 * @param titreY : le titre de l'axe Y
	 */
	public Araignee(Gestionnaire gest,Habilleur hab, String titreGraphe,String titreX,String titreY)
	{super(gest,hab,titreGraphe,titreX,titreY);}

	@Override
	protected XYDataset construireSeries()
	{
		setCanvas();
		m_data = new DefaultXYDataset();
		Iterator<Series> ite=getDonnee().iterator();
		Vector<Series> partiels=new Vector<Series>();
		double[][] don;
		int taille=0;
		int nb;
		while(ite.hasNext())
		{
			nb=0;
			Series s=ite.next();
			String cde=s.getSemantique();
			don=new double[2][s.getNbDonneeID()];
			for(int i=0;i<s.getNbDonneeID();i++)
			{
				if(s.getDonneeID(i) !=null)
				{
					if(!m_gestionnaire.isFantome(s.getDonneeID(i)))
					{
						don[0][nb]=s.getDonneeID(i).getCoord(m_gestionnaire.getAxeX());
//						System.out.println("first x : "+don[0][nb]);
						don[1][nb]=s.getDonneeID(i).getCoord(m_gestionnaire.getAxeY());
//						System.out.println("first y : "+don[1][nb]);
						m_canvas.addPoint(s.getDonneeID(i));
						if(s.getDonneeID(i) instanceof DonneeMoyenne && m_gestionnaire.isAffPartiels(s.getDonneeID(i)))
						{
							Series part=new Series();
							DonneeMoyenne donnee=(DonneeMoyenne)s.getDonneeID(i);
							for(int j=0;j<donnee.getNbBranches();j++)
							{
								part.addDonneeID(donnee.getBranches().get(j));								
								taille++;
							}
							partiels.add(part);
						}
						nb++;
					}
				}
			}
			double[][] donFinal=new double[2][nb];
			for(int i=0;i<nb;i++)
			{
				donFinal[0][i]=don[0][i];
				donFinal[1][i]=don[1][i];
			}
			if(nb!=0)((DefaultXYDataset)m_data).addSeries(cde, donFinal);
		}
		
		// ajout des points partiels au vecteur des points moyens
		
		don=new double[2][taille];
		int cpt=0;
		for(int i=0;i<partiels.size();i++)
		{
			m_partiel=true;
			for(int j=0;j<partiels.get(i).getNbDonneeID();j++)
			{
				don[0][cpt]=partiels.get(i).getDonneeID(j).getCoord(m_gestionnaire.getAxeX());
				don[1][cpt]=partiels.get(i).getDonneeID(j).getCoord(m_gestionnaire.getAxeY());
				m_canvas.addPoint(partiels.get(i).getDonneeID(j));
				cpt++;
			}
		}
		if(partiels.size()!=0)((DefaultXYDataset)m_data).addSeries("partiel", don);
		return m_data;
	}
}
