package dyn;

import ihm.Gestionnaire;
import ihm.Habilleur;

import java.util.Iterator;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.JFreeChart;
import org.jfree.data.xy.XYDataset;
import org.jfree.experimental.data.xy.VectorSeries;
import org.jfree.experimental.data.xy.VectorSeriesCollection;

import don.ContinueAnalysee;
import drawing.Series;

/**
 * Classe qui correspond au graphe des variables continues, orthonormees ou non (representees par des vecteurs)
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Vecteur extends Graphe
{
	/** constructeur 
	 * @param gest : le Gestionnaire qui commande le graphe 
	 * @param hab 
	 * @param titreGraphe : le titre du graphe 
	 * @param titreX : le titre de l'axe X 
	 * @param titreY : le titre de l'axe Y
	 */
	public Vecteur(Gestionnaire gest, Habilleur hab, String titreGraphe,String titreX,String titreY) {
		super(gest, hab, titreGraphe,titreX,titreY);
	}

	@Override 
	protected JFreeChart createChart(XYDataset dataset)
	{
		//variables orthonormees ou pas
		boolean pie = false;
		Iterator<Series> ite=getDonnee().iterator();
		if(ite.hasNext())
		{
			Series s=ite.next();
			if(s.getDonneeID(0) instanceof ContinueAnalysee)
			{
				ContinueAnalysee donnee=(ContinueAnalysee)s.getDonneeID(0);
				if(donnee.isOrthonorme())pie=true;
				else pie=false;
			}
		}
		//creation du graphique
		return ChartFactory.createPieVecPlot(getTitreGraphe(), getTitreX(),
				getTitreY(), dataset, pie, getOrientation(), m_gestionnaire.isAffLegende(), false, false);
	}

	@Override 
	protected XYDataset construireSeries()
	{
		setCanvas();
		m_data = new VectorSeriesCollection();
		Iterator<Series> ite=getDonnee().iterator();
		while(ite.hasNext())
		{	
			Series s=ite.next();
			String etiq=s.getSemantique();
			VectorSeries vect=new VectorSeries(etiq);
			int i=0;
			int nb=0;
			for(;i<s.getNbDonneeID();i++)
			{
				if(!m_gestionnaire.isFantome(s.getDonneeID(i)))
				{
					vect.add(0,0,s.getDonneeID(i).getCoord(m_gestionnaire.getAxeX()),
							s.getDonneeID(i).getCoord(m_gestionnaire.getAxeY()));
					m_canvas.addPoint(s.getDonneeID(i));
					nb++;
				}
			}
			if(nb!=0)((VectorSeriesCollection)m_data).addSeries(vect);
		}
		return m_data;
	}

}
