dynlis <- function (res.obj, nbrow, nbobj) 
{
    if (inherits(res.obj, "CA")) {
        if ((dim(res.obj$row$coord)[1] + length(rownames(res.obj$row.sup$coord))) < 
            nbrow) {
            stop("nbrow must be less than the number of active rows")
        }
        if ((dim(res.obj$col$coord)[1] + length(rownames(res.obj$col.sup$coord))) < 
            nbobj) {
            stop("nbobj must be less than the number of active columns")
        }
        if (!is.null(res.obj$row.sup)) {
            tab = as.matrix(res.obj$row.sup$coord)
            if (dim(res.obj$row.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = rowsupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  rowsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                rowsup_kept = rownames(tab[unique(unlist(rowsupext)), 
                  ])
                samp = sample(1:length(rowsup_kept), 20, replace = F)
                rowsup_kept2 = rowsup_kept[samp]
                names(rowsup_kept2) = colnames(rowsup_kept)[samp]
                rowsup_kept = rowsup_kept2
            }else {
                rowsup_kept = rownames(tab)
            }
        }else {
            rowsup_kept = NULL
        }
        tab = as.matrix(res.obj$row$coord)
        coordmean = coordsd = seuil = rowext = rowmoy = list()
        coordmean[[1]] = mean(tab[, 1])
        coordsd[[1]] = sd(tab[, 1])
        seuil[[1]] = coordmean[[1]] + coordsd[[1]]
        rowext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        rowmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            coordmean[[i]] = mean(tab[, i])
            coordsd[[i]] = sd(tab[, i])
            seuil[[i]] = coordmean[[i]] + coordsd[[i]]
            rowext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            rowmoy[[i]] = intersect(rowmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        rowext = unique(unlist(rowext))
        rowmoy = rowmoy[[5]]
        if (length(rowext) > (nbrow - length(rowsup_kept))) {
            rowext = rowext[sample(1:length(rowext), nbrow - 
                length(rowsup_kept), replace = F)]
        }
        if (length(rowmoy) > (nbrow - length(rowsup_kept) - length(rowext))) {
            rowmoy = rowmoy[sample(1:length(rowmoy), max(0,(nbrow - 
                length(rowsup_kept) - length(rowext))), replace = F)]
        }
        row_kept = sort(cbind(t(rowext), t(rowmoy)))
        if (!is.null(res.obj$col.sup)) {
            tab = as.matrix(res.obj$col.sup$coord)
            if (dim(res.obj$col.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = colsupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  colsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                colsup_kept = rownames(tab[unique(unlist(colsupext)), 
                  ])
                samp = sample(1:length(colsup_kept), 20, replace = F)
                colsup_kept2 = colsup_kept[samp]
                names(colsup_kept2) = colnames(colsup_kept)[samp]
                colsup_kept = colsup_kept2
            }else {
                colsup_kept = rownames(tab)
            }
        }else {
            colsup_kept = NULL
        }
        tab = as.matrix(res.obj$col$coord)
        coordmean = coordsd = seuil = colext = colmoy = list()
        coordmean[[1]] = mean(tab[, 1])
        coordsd[[1]] = sd(tab[, 1])
        seuil[[1]] = coordmean[[1]] + coordsd[[1]]
        colext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        colmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            coordmean[[i]] = mean(tab[, i])
            coordsd[[i]] = sd(tab[, i])
            seuil[[i]] = coordmean[[i]] + coordsd[[i]]
            colext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            colmoy[[i]] = intersect(colmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        colext = rownames(tab[unique(unlist(colext)), ])
        colmoy = rownames(tab[colmoy[[5]], ])
        if (length(colext) > (nbobj - length(colsup_kept))) {
            colext = colext[sample(1:length(colext), nbobj - 
                length(colsup_kept), replace = F)]
        }
        if (length(colmoy) > (nbobj - length(colsup_kept) - length(colext))) {
            colmoy = colmoy[sample(1:length(colmoy), max(0,nbobj - 
                length(colsup_kept) - length(colext)), replace = F)]
        }
        col_kept = cbind(t(colext), t(colmoy))
        res = res.obj
        res$row$coord = res.obj$row$coord[row_kept, ]
        res$row$cos2 = res.obj$row$cos2[row_kept, ]
        res$row$contrib = res.obj$row$contrib[row_kept, ]
        res$col$coord = res.obj$col$coord[col_kept, ]
        res$col$cos2 = res.obj$col$cos2[col_kept, ]
        res$col$contrib = res.obj$col$contrib[col_kept, ]
        res$call$X = res.obj$call$X[, col_kept]
        if (!is.null(res.obj$row.sup)) {
            if (length(rowsup_kept) != 0) {
                res$row.sup$coord = res.obj$row.sup$coord[rowsup_kept, 
                  ]
                res$row.sup$cos2 = res.obj$row.sup$cos2[rowsup_kept, 
                  ]
                res$call$row.sup = res.obj$call$row.sup
            }
            else {
                res$row.sup = NULL
                res$call$row.sup = NULL
            }
        }
        if (!is.null(res.obj$col.sup)) {
            if (length(colsup_kept) != 0) {
                res$col.sup$coord = res.obj$col.sup$coord[colsup_kept, 
                  ]
                res$col.sup$cor = res.obj$col.sup$cor[colsup_kept, 
                  ]
                res$col.sup$cos2 = res.obj$col.sup$cos2[colsup_kept, 
                  ]
                res$call$col.sup = res.obj$call$col.sup
            }
            else {
                res$col.sup = NULL
                res$call$col.sup = NULL
            }
        }
        res$call$X = res$call$X[sort(row_kept), ]
    }
    if (inherits(res.obj, "PCA")) {
        if ((dim(res.obj$ind$coord)[1] + length(rownames(res.obj$ind.sup$coord))) < 
            nbrow) {
            stop("nbrow must be less than the number of active individuals")
        }
        if ((dim(res.obj$var$coord)[1] + length(rownames(res.obj$quali.sup$coord)) + 
            length(rownames(res.obj$quanti.sup$coord))) < nbobj) {
            stop("nbobj must be less than the number of active variables")
        }
        if (!is.null(res.obj$ind.sup)) {
            tab = as.matrix(res.obj$ind.sup$coord)
            if (dim(res.obj$ind.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = indsupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  indsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                ind_sup_kept = rownames(tab[unique(unlist(indsupext)), 
                  ])
                samp = sample(1:length(ind_sup_kept), 20, replace = F)
                ind_sup_kept2 = ind_sup_kept[samp]
                names(ind_sup_kept2) = colnames(ind_sup_kept)[samp]
                ind_sup_kept = sort(ind_sup_kept2)
            }else {
                ind_sup_kept = rownames(tab)
            }
        }else {
            ind_sup_kept = NULL
        }
        tab = as.matrix(res.obj$ind$coord)
        coordmean = coordsd = seuil = indext = indmoy = list()
        coordmean[[1]] = mean(tab[, 1])
        coordsd[[1]] = sd(tab[, 1])
        seuil[[1]] = coordmean[[1]] + coordsd[[1]]
        indext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        indmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            coordmean[[i]] = mean(tab[, i])
            coordsd[[i]] = sd(tab[, i])
            seuil[[i]] = coordmean[[i]] + coordsd[[i]]
            indext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            indmoy[[i]] = intersect(indmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        indext = unique(unlist(indext))
        indmoy = indmoy[[5]]
        if (length(indext) > (nbrow - length(ind_sup_kept))) {
            indext = indext[sample(1:length(indext), nbrow - 
                length(ind_sup_kept), replace = F)]
        }
        if (length(indmoy) > (nbrow - length(ind_sup_kept) - 
            length(indext))) {
            indmoy = indmoy[sample(1:length(indmoy), max(0,(nbrow - 
                length(ind_sup_kept) - length(indext))), replace = F)]
        }
        ind_kept = sort(cbind(t(indext), t(indmoy)))
        if (!is.null(res.obj$quali.sup)) {
            tab = as.matrix(res.obj$quali.sup$v.test)
            if (dim(tab)[1] > 20) {
                vtestmean = vtestsd = seuil = modsupext = list()
                for (i in 1:dim(tab)[2]) {
                  vtestmean[[i]] = mean(tab[, i])
                  vtestsd[[i]] = sd(tab[, i])
                  seuil[[i]] = vtestmean[[i]] + vtestsd[[i]]
                  modsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                mod_qualisup_kept = rownames(tab[unique(unlist(modsupext)), 
                  ])
            }else {
                mod_qualisup_kept = rownames(tab)
            }
            varqualisup = nbmod = c()
            if (length(mod_qualisup_kept) != 0) {
                for (i in mod_qualisup_kept) {
                  for (j in colnames(res.obj$call$quali.sup$quali.sup)) {
                    if (i %in% levels(res.obj$call$X[, j, drop = F][, 
                      1]) | strsplit(i, "_")[[1]][2] %in% levels(res.obj$call$X[, 
                      j, drop = F][, 1])) {
                      varqualisup = c(varqualisup, j)
                      nbmod = c(nbmod, nlevels(res.obj$call$X[, 
                        j, drop = F][, 1]))
                    }
                  }
                }
                varqualisup = unique(varqualisup)
                nbmodpvar = mean(nbmod)
                if (length(varqualisup) > 20/nbmodpvar) {
                  samp = sample(1:length(varqualisup), 20/nbmodpvar, 
                    replace = F)
                  varqualisup2 = varqualisup[samp]
                  varqualisup = varqualisup2
                }
                levqualisup = c()
                for (i in varqualisup) {
                  levqualisup = c(levqualisup, levels(res.obj$call$X[, 
                    i]))
                }
            }
        }else {
            varqualisup = levqualisup = NULL
        }
        if (!is.null(res.obj$quanti.sup)) {
            tab = as.matrix(res.obj$quanti.sup$coord)
            if (dim(res.obj$quanti.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = varsupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  varsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                var_quantisup_kept = rownames(tab[unique(unlist(varsupext)), 
                  ])
                samp = sample(1:length(var_quantisup_kept), 20, 
                  replace = F)
                var_quantisup_kept2 = var_quantisup_kept[samp]
                names(var_quantisup_kept2) = colnames(var_quantisup_kept)[samp]
                var_quantisup_kept = var_quantisup_kept2
            }else {
                var_quantisup_kept = rownames(tab)
            }
        }else {
            var_quantisup_kept = NULL
        }
        tab = as.matrix(res.obj$var$coord)
        coordmean = coordsd = seuil = varext = varmoy = list()
        coordmean[[1]] = mean(tab[, 1])
        coordsd[[1]] = sd(tab[, 1])
        seuil[[1]] = coordmean[[1]] + coordsd[[1]]
        varext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        varmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            coordmean[[i]] = mean(tab[, i])
            coordsd[[i]] = sd(tab[, i])
            seuil[[i]] = coordmean[[i]] + coordsd[[i]]
            varext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            varmoy[[i]] = intersect(varmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        varext = rownames(tab[unique(unlist(varext)), ])
        varmoy = rownames(tab[varmoy[[5]], ])
        var_kept = cbind(t(varext), t(varmoy))
        nbvarpct = (nbobj - length(var_quantisup_kept) - length(levqualisup))/nrow(tab)
        if (nbvarpct > 1) {
            nbvarpct = 1
        }
        if (length(varext) > (nbobj - length(var_quantisup_kept) - 
            length(levqualisup))) {
            varext = varext[sample(1:length(varext), (nbobj - 
                length(var_quantisup_kept) - length(levqualisup)), 
                replace = F)]
        }
        if (length(varmoy) > ((nbobj - length(var_quantisup_kept) - 
            length(levqualisup)) - length(varext))) {
            varmoy = varmoy[sample(1:length(varmoy), max(0,((nbobj - 
                length(var_quantisup_kept) - length(levqualisup)) - 
                length(varext))), replace = F)]
        }
        var_kept = cbind(t(varext), t(varmoy))
        res = res.obj
        res$ind$coord = res.obj$ind$coord[ind_kept, ]
        res$ind$cos2 = res.obj$ind$cos2[ind_kept, ]
        res$ind$contrib = res.obj$ind$contrib[ind_kept, ]
        if (!is.null(res.obj$ind.sup)) {
            if (length(ind_sup_kept) != 0) {
                res$ind.sup$coord = res.obj$ind.sup$coord[ind_sup_kept, 
                  ]
                res$ind.sup$cos2 = res.obj$ind.sup$cos2[ind_sup_kept, 
                  ]
                res$call$ind.sup = which(rownames(res.obj$call$X) %in% 
                  ind_sup_kept)
            }else {
                res$ind.sup = NULL
                res$call$ind.sup = NULL
            }
        }
        res$var$coord = res.obj$var$coord[var_kept, ]
        res$var$cos2 = res.obj$var$cos2[var_kept, ]
        res$var$contrib = res.obj$var$contrib[var_kept, ]
        res$call$X = rbind(res.obj$call$X[which(!rownames(res.obj$call$X) %in% 
            rownames(res.obj$ind.sup$coord)), var_kept], res.obj$call$X[ind_sup_kept, 
            var_kept])
        if (!is.null(res.obj$quali.sup)) {
            if (length(varqualisup) != 0) {
                res$quali.sup$coord = res.obj$quali.sup$coord[levqualisup, 
                  ]
                res$quali.sup$cos2 = res.obj$quali.sup$cos2[levqualisup, 
                  ]
                res$quali.sup$v.test = res.obj$quali.sup$v.test[levqualisup, 
                  ]
                res$call$quali.sup$quali.sup = res.obj$call$quali.sup$quali.sup[, 
                  varqualisup, drop = F]
                res$call$X = cbind(res$call$X, rbind(res$call$quali.sup$quali.sup, 
                  res.obj$call$X[ind_sup_kept, varqualisup, drop = F]))
                res$call$quali.sup$quali.sup = res$call$quali.sup$quali.sup[ind_kept, 
                  , drop = F]
            }else {
                res$quali.sup = NULL
                res$call$quali.sup = NULL
            }
        }
        if (!is.null(res.obj$quanti.sup)) {
            if (length(var_quantisup_kept) != 0) {
                res$quanti.sup$coord = res.obj$quanti.sup$coord[var_quantisup_kept, 
                  ]
                res$quanti.sup$cor = res.obj$quanti.sup$cor[var_quantisup_kept, 
                  ]
                res$quanti.sup$cos2 = res.obj$quanti.sup$cos2[var_quantisup_kept, 
                  ]
                res$call$quanti.sup = res.obj$call$quanti.sup[, 
                  var_quantisup_kept, drop = F]
                res$call$X = cbind(res$call$X, rbind(res$call$quanti.sup, 
                  res.obj$call$X[ind_sup_kept, var_quantisup_kept, 
                    drop = F]))
                res$call$quanti.sup = res$call$quanti.sup[ind_kept, 
                  , drop = F]
            }else {
                res$quanti.sup = NULL
                res$call$quanti.sup = NULL
            }
        }
        res$call$X = rbind.data.frame(res$call$X[sort(ind_kept), 
            ], res$call$X[rownames(res$call$X) %in% ind_sup_kept, 
            ])
    }
    if (inherits(res.obj, "MCA")) {
        if ((dim(res.obj$ind$coord)[1] + length(rownames(res.obj$ind.sup$coord))) < 
            nbrow) {
            stop("nbrow must be less than the number of active individuals")
        }
        if ((dim(res.obj$var$coord)[1] + length(rownames(res.obj$quali.sup$coord)) + 
            length(rownames(res.obj$quanti.sup$coord))) < nbobj) {
            stop("nbobj must be less than the number of active categories")
        }
        if (!is.null(res.obj$ind.sup)) {
            tab = as.matrix(res.obj$ind.sup$coord)
            if (dim(res.obj$ind.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = indsupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  indsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                ind_sup_kept = rownames(tab[unique(unlist(indsupext)), 
                  ])
                samp = sample(1:length(ind_sup_kept), 20, replace = F)
                ind_sup_kept2 = ind_sup_kept[samp]
                names(ind_sup_kept2) = colnames(ind_sup_kept)[samp]
                ind_sup_kept = ind_sup_kept2
            }else {
                ind_sup_kept = rownames(tab)
            }
        }else {
            ind_sup_kept = NULL
        }
        tab = as.matrix(res.obj$ind$coord)
        coordmean = coordsd = seuil = indext = indmoy = list()
        coordmean[[1]] = mean(tab[, 1])
        coordsd[[1]] = sd(tab[, 1])
        seuil[[1]] = coordmean[[1]] + coordsd[[1]]
        indext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        indmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            coordmean[[i]] = mean(tab[, i])
            coordsd[[i]] = sd(tab[, i])
            seuil[[i]] = coordmean[[i]] + coordsd[[i]]
            indext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            indmoy[[i]] = intersect(indmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        indext = unique(unlist(indext))
        indmoy = indmoy[[5]]
        if (length(indext) > (nbrow - length(ind_sup_kept))) {
            indext = indext[sample(1:length(indext), nbrow - 
                length(ind_sup_kept), replace = F)]
        }
        if (length(indmoy) > (nbrow - length(ind_sup_kept) - 
            length(indext))) {
            indmoy = indmoy[sample(1:length(indmoy), max(0,(nbrow - 
                length(ind_sup_kept) - length(indext))), replace = F)]
        }
        ind_kept = sort(cbind(t(indext), t(indmoy)))
        if (!is.null(res.obj$quali.sup)) {
            tab = as.matrix(res.obj$quali.sup$v.test)
            if (dim(tab)[1] > 20) {
                vtestmean = vtestsd = seuil = modsupext = list()
                for (i in 1:dim(tab)[2]) {
                  vtestmean[[i]] = mean(tab[, i])
                  vtestsd[[i]] = sd(tab[, i])
                  seuil[[i]] = vtestmean[[i]] + vtestsd[[i]]
                  modsupext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
                }
                mod_qualisup_kept = rownames(tab[unique(unlist(modsupext)), 
                  ])
            }else {
                mod_qualisup_kept = rownames(tab)
            }
            varqualisup = nbmod = c()
            if (length(mod_qualisup_kept) != 0) {
                for (i in mod_qualisup_kept) {
                  for (j in res.obj$call$quali.sup) {
                    if (i %in% levels(res.obj$call$X[, j, drop = F][, 
                      1]) | strsplit(i, "_")[[1]][2] %in% levels(res.obj$call$X[, 
                      j, drop = F][, 1])) {
                      varqualisup = c(varqualisup, j)
                      nbmod = c(nbmod, nlevels(res.obj$call$X[, 
                        j, drop = F][, 1]))
                    }
                  }
                }
                varqualisup = unique(varqualisup)
                nbmodpvar = mean(nbmod)
                if (length(varqualisup) > 20/nbmodpvar) {
                  samp = sample(1:length(varqualisup), 20/nbmodpvar, 
                    replace = F)
                  varqualisup2 = varqualisup[samp]
                  varqualisup = varqualisup2
                }
                levqualisup = c()
                for (i in varqualisup) {
                  levqualisup = c(levqualisup, levels(res.obj$call$X[, 
                    i]))
                }
            }
        }else {
            varqualisup = levqualisup = NULL
        }
        if (!is.null(res.obj$quanti.sup)) {
            tab = as.matrix(res.obj$quanti.sup$coord)
            if (dim(res.obj$quanti.sup$coord)[1] > 20) {
                coordmean = coordsd = seuil = quantisupext = list()
                for (i in 1:dim(tab)[2]) {
                  coordmean[[i]] = mean(tab[, i])
                  coordsd[[i]] = sd(tab[, i])
                  seuil[[i]] = coordmean[[i]] + coordsd[[i]]
                  quantisupext[[i]] = which(abs(tab[, i]) >= 
                    seuil[[i]])
                }
                varquantisup = rownames(tab[unique(unlist(quantisupext)), 
                  ])
                samp = sample(1:length(varquantisup), 20, replace = F)
                varquantisup2 = varquantisup[samp]
                names(varquantisup2) = colnames(varquantisup)[samp]
                varquantisup = varquantisup2
            }else {
                varquantisup = rownames(tab)
            }
        }else {
            varquantisup = NULL
        }
        tab = as.matrix(res.obj$var$v.test)
        vtestmean = vtestsd = seuil = modext = modmoy = list()
        vtestmean[[1]] = mean(tab[, 1])
        vtestsd[[1]] = sd(tab[, 1])
        seuil[[1]] = vtestmean[[1]] + vtestsd[[1]]
        modext[[1]] = which(abs(tab[, 1]) >= seuil[[1]])
        modmoy[[1]] = which(abs(tab[, 1]) < seuil[[1]])
        for (i in 2:dim(tab)[2]) {
            vtestmean[[i]] = mean(tab[, i])
            vtestsd[[i]] = sd(tab[, i])
            seuil[[i]] = vtestmean[[i]] + vtestsd[[i]]
            modext[[i]] = which(abs(tab[, i]) >= seuil[[i]])
            modmoy[[i]] = intersect(modmoy[[i - 1]], which(abs(tab[, 
                i]) < seuil[[i]]))
        }
        modext = rownames(tab[unique(unlist(modext)), ])
        modmoy = rownames(tab[modmoy[[5]], ])
        mod_kept = cbind(t(modext), t(modmoy))
        varext = varmoy = nbmod = c()
        for (i in mod_kept) {
            if (is.null(res.obj$call$quali.sup) & is.null(res.obj$call$quanti.sup)) {
                tabX = res.obj$call$X
            }else {
                tabX = res.obj$call$X[, -c(res.obj$call$quali.sup, 
                  res.obj$call$quanti.sup)]
            }
            for (j in 1:ncol(tabX)) {
                if (i %in% levels(res.obj$call$X[, colnames(res.obj$call$X)[j]]) | 
                  strsplit(i, "_")[[1]][2] %in% levels(res.obj$call$X[, 
                    colnames(res.obj$call$X)[j]])) {
                  if (i %in% modext) {
                    if (!j %in% varext & !j %in% varmoy) 
                      varext = c(varext, j)
                    nbmod = c(nbmod, nlevels(tabX[, j]))
                  }
                  if (i %in% modmoy) {
                    if (!j %in% varext & !j %in% varmoy) 
                      varmoy = c(varmoy, j)
                    nbmod = c(nbmod, nlevels(tabX[, j]))
                  }
                }
            }
        }
        nbmodpvar = mean(nbmod)
        nbvarpct = (nbobj - length(levqualisup) - length(varquantisup))/nrow(tab)
        if (nbvarpct > 1) {
            nbvarpct = 1
        }
        if (length(varext) > nbvarpct * ncol(tabX)) {
            varext = varext[sample(1:length(varext), nbvarpct * 
                ncol(tabX), replace = F)]
        }
        if (length(varmoy) > max(0, (((nbobj - length(levqualisup) - 
            length(varquantisup))/nbmodpvar) - length(varext)))) {
            varmoy = varmoy[sample(1:length(varmoy), max(0,(((nbobj - 
                length(levqualisup) - length(varquantisup))/nbmodpvar) - 
                length(varext))), replace = F)]
        }
        var = unique(c(varext, varmoy))
        lev = c()
        for (i in 1:ncol(tabX[, var])) {
            lev = c(lev, levels(tabX[, var][, i]))
        }
        res = res.obj
        res$ind$coord = res.obj$ind$coord[ind_kept, ]
        res$ind$cos2 = res.obj$ind$cos2[ind_kept, ]
        res$ind$contrib = res.obj$ind$contrib[ind_kept, ]
        if (!is.null(res.obj$ind.sup)) {
            if (length(ind_sup_kept) != 0) {
                res$ind.sup$coord = res.obj$ind.sup$coord[ind_sup_kept, 
                  ]
                res$ind.sup$cos2 = res.obj$ind.sup$cos2[ind_sup_kept, 
                  ]
                res$call$ind.sup = which(rownames(res.obj$call$X) %in% 
                  ind_sup_kept)
            }else {
                res$ind = NULL
                res$call$ind.sup = NULL
            }
        }
        res$var$coord = res.obj$var$coord[which(rownames(res.obj$var$coord) %in% 
            lev), ]
        res$var$cos2 = res.obj$var$cos2[which(rownames(res.obj$var$cos2) %in% 
            lev), ]
        res$var$contrib = res.obj$var$contrib[which(rownames(res.obj$var$contrib) %in% 
            lev), ]
        res$var$v.test = res.obj$var$v.test[which(rownames(res.obj$var$v.test) %in% 
            lev), ]
        res$call$X = tabX[, var]
        res$call$quali = 1:ncol(res$call$X)
        res$call$marge.col = res.obj$call$marge.col[which(names(res.obj$call$marge.col) %in% 
            lev)]
        if (!is.null(res.obj$quali.sup)) {
            if (length(varqualisup) != 0) {
                res$call$X = cbind(res$call$X, res.obj$call$X[, 
                  varqualisup, drop = F])
                res$call$quali.sup = (length(var) + 1):ncol(res$call$X)
                res$quali.sup$coord = res.obj$quali.sup$coord[which(rownames(res.obj$quali.sup$coord) %in% 
                  levqualisup), ]
                res$quali.sup$cos2 = res.obj$quali.sup$cos2[which(rownames(res.obj$quali.sup$cos2) %in% 
                  levqualisup), ]
                res$quali.sup$v.test = res.obj$quali.sup$v.test[which(rownames(res.obj$quali.sup$v.test) %in% 
                  levqualisup), ]
            }else {
                res$quali.sup = NULL
                res$call$quali.sup = NULL
            }
        }
        if (!is.null(res.obj$quanti.sup)) {
            if (length(varquantisup) != 0) {
                res$call$X = cbind(res$call$X, res.obj$call$X[, 
                  varquantisup, drop = F])
                res$call$quanti.sup = (length(var) + length(varqualisup) + 
                  1):ncol(res$call$X)
                res$quanti.sup$coord = res.obj$quanti.sup$coord[varquantisup, 
                  , drop = F]
            }else {
                res$quanti.sup = NULL
                res$call$quanti.sup = NULL
            }
        }
        res$call$X = rbind.data.frame(res$call$X[rownames(res.obj$call$X[which(!rownames(res.obj$call$X) %in% 
            ind_sup_kept), ])[sort(ind_kept)], ], res$call$X[ind_sup_kept, 
            ])
    }
    return(res)
}