\name{dynlis}
\alias{dynlis}

\title{Interactive visualization of dataframes and factorial planes}
\description{
dynGraph is a java application that allows to interact with the representation of scatterplots from a dataframe or 
from a multivariate analysis performed with the FactoMineR package
}

\usage{
dynlis(res.obj, nbrow, nbobj)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{res.obj}{\code{res.obj} can be either a dataframe or results provided by a PCA, CA, MCA, MFA with the FactoMineR package}
  \item{nbrow}{\code{proba} is the threshold use to represent objects}
  \item{nbobj}{\code{proba} is the threshold use to represent objects}
}
\author{Sebastien Le and Gwenaelle Fournier}

\examples{
\dontrun{
library(FactoMineR)

data(wine)
dynGraph(wine)

data(decathlon)
res.pca <- PCA(decathlon, quanti.sup = 11:12, quali.sup=13)
dynGraph(res.pca)
}
}
\keyword{multivariate}
\keyword{internal}