package ihm;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import org.jfree.ui.RefineryUtilities;

import don.Continue;
import don.ContinueAnalysee;
import don.DonneeParse;

/** Fenêtre qui permet de modifier les axes 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class FenetreChoixAxes extends JDialog
{
	private static final long serialVersionUID = 1L;

	/** éléments graphique  */
	
	/** conteneur */
	protected JPanel m_contentPane = null;

	/** label axe X */
	private JLabel m_lblX = null;

	/** label axe y */
	private JLabel m_lblY = null;
	
	/** barre d�fillement X */
	private JScrollPane m_scrollX = null;

	/** barre d�fillement Y */
	private JScrollPane m_scrollY = null;

	/** liste X */
	protected JList m_lstX;

	/** liste Y */
	protected JList m_lstY;

	/** case à cocher pour afficher l'inertie */
	protected JCheckBox m_chkAffInertie = null;

	/** bouton annuler */
	private JButton m_btAnnuler = null;

	/** bouton ok */
	private JButton m_btOk = null;
	
	/** attributs  */
	
	/** le Gestionnaire */
	transient protected Gestionnaire m_gestionnaire;

	private JPanel jPanelOkAnnuler = null;

	private JCheckBox m_checkBoxOrtho;

	/** Constructeur
	 * @param owner
	 * @param gest 
	 */
	public FenetreChoixAxes(Frame owner, Gestionnaire gest)
	{
		super(owner);
		m_gestionnaire=gest;
		initialize();
	}

	protected FenetreChoixAxes(Frame owner) {
		super(owner);
	}

	/** This method initializes this */
	protected void initialize()
	{
		setTitle(IHM.getXmlLangue().getElement("Taxe"));
		setContentPane(getJContentPane());
		pack();
		RefineryUtilities.centerFrameOnScreen(this);
		setResizable(false);
		setVisible(true);
	}

	/** This method initializes m_contentPane
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (m_contentPane == null)
		{
			GridBagConstraints okAnnuler = new GridBagConstraints();
			okAnnuler.gridy = 4;
			okAnnuler.gridx = 0;
			okAnnuler.fill = GridBagConstraints.HORIZONTAL;
			okAnnuler.gridwidth = 4;
			GridBagConstraints checkbox = new GridBagConstraints();
			checkbox.gridx = 0;
			checkbox.gridy = 2;
			checkbox.fill = GridBagConstraints.HORIZONTAL;
			checkbox.gridwidth = 4;
			GridBagConstraints scrollpaneY = new GridBagConstraints();
			scrollpaneY.fill = GridBagConstraints.BOTH;
			scrollpaneY.gridx = 3;
			scrollpaneY.gridy = 0;
			scrollpaneY.insets = new Insets(4, 8, 4, 8);
			GridBagConstraints scrollpaneX = new GridBagConstraints();
			scrollpaneX.fill = GridBagConstraints.BOTH;
			scrollpaneX.gridx = 1;
			scrollpaneX.gridy = 0;
			scrollpaneX.insets = new Insets(4, 8, 4, 8);
			GridBagConstraints labelY = new GridBagConstraints();
			labelY.gridy = 0;
			labelY.gridx = 2;
			labelY.insets = new Insets(4, 8, 4, 8);
			labelY.anchor=GridBagConstraints.NORTH;
			GridBagConstraints labelX = new GridBagConstraints();
			labelX.gridy = 0;
			labelX.gridx = 0;
			labelX.insets = new Insets(4, 8, 4, 8);
			labelX.anchor=GridBagConstraints.NORTH;
			m_lblY = new JLabel();
			m_lblY.setText(IHM.getXmlLangue().getElement("LaxeY")+" : ");
			m_lblX = new JLabel();
			m_lblX.setText(IHM.getXmlLangue().getElement("LaxeX")+" : ");
			m_contentPane = new JPanel();
			m_contentPane.setLayout(new GridBagLayout());
			m_contentPane.add(m_lblX, labelX);
			m_contentPane.add(m_lblY, labelY);
			ajouterLabelsInertie();
			m_contentPane.add(getJScrollPaneX(), scrollpaneX);
			m_contentPane.add(getJScrollPaneY(), scrollpaneY);
			m_contentPane.add(getJCheckBox(), checkbox);
			ajouterCheckBoxOrthonorme();
			m_contentPane.add(getJPanelOkAnnuler(), okAnnuler);
		}
		return m_contentPane;
	}

	private void ajouterCheckBoxOrthonorme() {
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.gridy = 3;
		constraints.gridx = 0;
		constraints.fill = GridBagConstraints.HORIZONTAL;
		constraints.gridwidth = 4;
		
		m_checkBoxOrtho = new JCheckBox(IHM.getXmlLangue().getElement("Lorthonormer"));
		m_checkBoxOrtho.setSelected(m_gestionnaire.isOrtho());
		m_contentPane.add(m_checkBoxOrtho, constraints);
	}

	protected void ajouterLabelsInertie() {		
	}

	/** This method initializes m_btAnnuler	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAnnuler()
	{
		if (m_btAnnuler == null)
		{
			m_btAnnuler = new JButton();
			m_btAnnuler.setText(IHM.getXmlLangue().getElement("Lannuler"));
			m_btAnnuler.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent e) {
					dispose();
				}
			});
		}
		return m_btAnnuler;
	}

	/** This method initializes m_btOk	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOK()
	{
		if (m_btOk == null)
		{
			m_btOk = new JButton();
			m_btOk.setText(IHM.getXmlLangue().getElement("Lok"));
			m_btOk.addActionListener(new ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					ContinueAnalysee axeX=(ContinueAnalysee) m_lstX.getSelectedValue();
					ContinueAnalysee axeY=(ContinueAnalysee) m_lstY.getSelectedValue();
					if(!axeX.equals(axeY)){
						m_gestionnaire.sauverAnnotations();
						m_gestionnaire.setAxeX(axeX);
						m_gestionnaire.setAxeY(axeY);
						m_gestionnaire.setOrtho(m_checkBoxOrtho.isSelected());					
						String x=m_gestionnaire.getTitreXDefaut();
						String y=m_gestionnaire.getTitreYDefaut();
						if(m_chkAffInertie.isSelected())
						{
							x+=" ("+m_gestionnaire.getInertieX()+")";
							y+=" ("+m_gestionnaire.getInertieY()+")";
						}
						m_gestionnaire.setTitreAxeX(x);
						m_gestionnaire.setTitreAxeY(y);
						m_gestionnaire.updateGraphe();
						dispose();
					}else{
						JOptionPane.showMessageDialog(FenetreChoixAxes.this, IHM.getXmlLangue().getElement("axesDifferents"), IHM.getXmlLangue().getElement("erreur"), JOptionPane.ERROR_MESSAGE);
					}
				};
			});
		}
		return m_btOk;
	}

	/** This method initializes m_scrollX	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneX() {
		if (m_scrollX == null) {
			Vector<Continue> elements=getElements();
			m_lstX = new JList(elements);
			m_lstX.setSelectedValue(m_gestionnaire.getAxeX(), true);
			m_lstX.setCellRenderer(new NomContinueCellRenderer());
			ajouterListelistenerX();
			m_scrollX = new JScrollPane(m_lstX);
		}
		return m_scrollX;
	}

	protected void ajouterListelistenerX() {		
	}
	
	protected void ajouterListelistenerY() {		
	}

	protected Vector<Continue> getElements() {
		Vector<Continue> elements = getAxes();
		elements.addAll(getContinues());
		return elements;
	}
	
	protected Vector<Continue> getAxes(){
		Vector<Continue> elements = new Vector<Continue>();
		DonneeParse don=m_gestionnaire.getDon();		
		for(int i=0;i<don.getNbAxe();i++){
			elements.add(don.getAxe(i));
		}
		return elements;
	}
	
	protected Vector<Continue> getContinues(){
		Vector<Continue> elements = new Vector<Continue>();
		DonneeParse don=m_gestionnaire.getDon();
		for (Continue cont : don.getVariablesMoyennes()) {
			elements.add(cont);
		}
		return elements;
	}

	/** This method initializes m_scrollY	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneY()
	{
		if (m_scrollY == null)
		{
			Vector<Continue> elements=getElements();
			m_lstY = new JList(elements);
			m_lstY.setSelectedValue(m_gestionnaire.getAxeY(), true);
			m_lstY.setCellRenderer(new NomContinueCellRenderer());
			ajouterListelistenerY();
			m_scrollY = new JScrollPane(m_lstY);
		}
		return m_scrollY;
	}

	/** This method initializes m_chkAffInertie	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBox()
	{
		if (m_chkAffInertie == null)
		{
			m_chkAffInertie = new JCheckBox();
			m_chkAffInertie.setText(IHM.getXmlLangue().getElement("LaffInertieAxes"));
			configurerCheckBoxInerties();
		}
		return m_chkAffInertie;
	}
	
	protected void configurerCheckBoxInerties() {
		m_chkAffInertie.setSelected(false);
		m_chkAffInertie.setEnabled(false);
	}

	protected static class NomContinueCellRenderer implements ListCellRenderer{

		public Component getListCellRendererComponent(JList arg0, Object arg1, int arg2, boolean arg3, boolean arg4) {
			if(arg1 instanceof Continue){
				Continue cont=(Continue)arg1;
				return new JLabel(cont.getAnnotation());
			}else
				return new JLabel("*error");
		}
		
	}

	/**
	 * This method initializes jPanelOkAnnuler	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelOkAnnuler() {
		if (jPanelOkAnnuler == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new Insets(8, 0, 8, 0);  
			gridBagConstraints1.weightx = 1.0;  
			gridBagConstraints1.gridx = 4;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new Insets(8, 0, 8, 0); 
			gridBagConstraints.weightx = 1.0;  
			gridBagConstraints.gridx = 5;
			jPanelOkAnnuler = new JPanel();
			jPanelOkAnnuler.setLayout(new BorderLayout());  
			JPanel ssPanelOkAnnuler = new JPanel();
			ssPanelOkAnnuler.add(getJButtonOK(), gridBagConstraints1);  
			ssPanelOkAnnuler.add(getJButtonAnnuler(), gridBagConstraints); 
			jPanelOkAnnuler.add(ssPanelOkAnnuler,BorderLayout.EAST);
		}
		return jPanelOkAnnuler;
	}
}