package ihm;

import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.util.Vector;
import javax.swing.JLabel;
import don.Continue;
import don.Dimension;
import don.DonneeParse;

import actions.ActionChangerAxe;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class FenetreChoixAxesFactoriels extends FenetreChoixAxes {


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/** tableau des inerties*/
	private double[] m_inerties;

	/** label inertie X */
	private JLabel m_lblInertieX = null;

	/** label inertie Y */
	private JLabel m_lblInertieY = null;
	
	
	/**
	 * @param owner
	 * @param inerties
	 * @param nbAxes
	 * @param gest
	 */
	public FenetreChoixAxesFactoriels(Frame owner, double[] inerties, int nbAxes, Gestionnaire gest)
	{
		super(owner);
		m_gestionnaire=gest;
		m_inerties=inerties.clone();
		initialize();
	}
	
	protected Vector<Continue> getElements() {
		return getAxes();
	}
	
	protected void ajouterListelistenerX() {
		m_lstX.addListSelectionListener(new ActionChangerAxe(m_lstX,m_lblInertieX,m_inerties));		
	}
	
	protected void ajouterListelistenerY() {
		m_lstY.addListSelectionListener(new ActionChangerAxe(m_lstY,m_lblInertieY,m_inerties));		
	}
	

	protected void ajouterLabelsInertie() {		
		GridBagConstraints labelY = new GridBagConstraints();
		labelY.fill = GridBagConstraints.BOTH;
		labelY.gridx = 3;
		labelY.gridy = 1;
		GridBagConstraints labelX = new GridBagConstraints();
		labelX.fill = GridBagConstraints.BOTH;
		labelX.gridx = 1;
		labelX.gridy = 1;
		
		m_lblInertieY = new JLabel();
		int numX = ((Dimension)m_gestionnaire.getAxeY()).getNum();
		m_lblInertieY.setText(DonneeParse.pourcentage(m_inerties[numX]));
		m_lblInertieX = new JLabel();
		int numY = ((Dimension)m_gestionnaire.getAxeX()).getNum();
		m_lblInertieX.setText(DonneeParse.pourcentage(m_inerties[numY]));
		m_contentPane.add(m_lblInertieX, labelX);
		m_contentPane.add(m_lblInertieY, labelY);
	}
	
	protected void configurerCheckBoxInerties() {
		m_chkAffInertie.setSelected(true);
		m_chkAffInertie.setEnabled(true);
	}
	
}
