package ihm;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import outils.Variables;

/**
 * @author sylvain.trovalet@gmail.com
 * 
 */
public class FenetreChoixTailleAnnotations extends JDialog {

	/** éléments graphique */

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/** conteneur */
	private JPanel jContentPane = null;

	/** label Size */
	private JPanel m_panelSize = null;
	private JLabel m_lblSize = null;
	private JComboBox JComboBoxSize;

	/** label Max Size */
	private JPanel m_panelMaxSize = null;
	private JLabel m_lblMaxSize = null;
	private JComboBox JComboBoxMaxSize;

	/** label Min Size */
	private JPanel m_panelMinSize = null;
	private JLabel m_lblMinSize = null;
	private JComboBox JComboBoxMinSize;

	private JPanel m_panelOkAnnuler = null;

	/** bouton ok */
	private JButton m_btOk = null;

	/** bouton annuler */
	private JButton m_btAnnuler = null;

	/** attributs */

	/** le Gestionnaire */
	private Gestionnaire m_gestionnaire;

	private int tailleAnnotations = Variables.getTaillePOLICE_ANNOTATIONS();
	private int tailleMaxAnnotations = Variables.getTAILLE_MAX_POLICE_ANNOTATIONS();
	private int tailleMinAnnotations = Variables.getTAILLE_MIN_POLICE_ANNOTATIONS();

	/**
	 * @return la taille des annotations
	 */
	public int getTailleAnnotations() {
		return tailleAnnotations;
	}

	/**
	 * @param tailleAnnotations
	 */
	public void setTailleAnnotations(int tailleAnnotations) {
		this.tailleAnnotations = tailleAnnotations;
	}

	/**
	 * @return la taille max des annotations
	 */
	public int getTailleMaxAnnotations() {
		return tailleMaxAnnotations;
	}

	/**
	 * @param tailleMaxAnnotations
	 */
	public void setTailleMaxAnnotations(int tailleMaxAnnotations) {
		this.tailleMaxAnnotations = tailleMaxAnnotations;
	}

	/**
	 * @return la taille min des annotations
	 */
	public int getTailleMinAnnotations() {
		return tailleMinAnnotations;
	}

	/**
	 * @param tailleMinAnnotations
	 */
	public void setTailleMinAnnotations(int tailleMinAnnotations) {
		this.tailleMinAnnotations = tailleMinAnnotations;
	}

	/**
	 * @param owner
	 * @param gest
	 */
	public FenetreChoixTailleAnnotations(Frame owner, Gestionnaire gest) {
		super(owner);
		m_gestionnaire = gest;
		initialize();
	}

	private void initialize() {
		setContentPane(getJContentPane());
		setTitle(IHM.getXmlLangue().getElement("TtailleAnnotations"));
		pack();
		setResizable(false);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();

			m_panelSize = new JPanel();
			GridBagConstraints labelSize = new GridBagConstraints();
			labelSize.gridx = 0;
			labelSize.gridy = 0;
			labelSize.insets = new Insets(4, 8, 4, 8);
			labelSize.anchor = GridBagConstraints.EAST;
			m_lblSize = new JLabel();
			m_lblSize.setText(IHM.getXmlLangue().getElement("LtailleAnnotations")+ " : ");
			m_panelSize.add(m_lblSize, labelSize);
//			jContentPane.add(m_lblSize,labelSize);
			GridBagConstraints gridBagConstraintsComboSize = new GridBagConstraints();
			gridBagConstraintsComboSize.fill = GridBagConstraints.WEST;
			gridBagConstraintsComboSize.anchor = GridBagConstraints.WEST;
			gridBagConstraintsComboSize.gridx = 1;
			gridBagConstraintsComboSize.gridy = 0;
			gridBagConstraintsComboSize.insets = new Insets(6, 6, 6, 6);
			m_panelSize.add(getJComboBoxSize(), gridBagConstraintsComboSize);
//			jContentPane.add(getJComboBoxSize(), gridBagConstraintsComboSize);

			m_panelMaxSize = new JPanel();
			GridBagConstraints labelMaxSize = new GridBagConstraints();
			labelMaxSize.gridx = 0;
			labelMaxSize.gridy = 1;
			labelMaxSize.insets = new Insets(4, 8, 4, 8);
			labelMaxSize.anchor = GridBagConstraints.EAST;
			m_lblMaxSize = new JLabel();
			m_lblMaxSize.setText(IHM.getXmlLangue().getElement("LtailleMaxAnnotations")+ " : ");
			m_panelMaxSize.add(m_lblMaxSize, labelMaxSize);
//			jContentPane.add(m_lblMaxSize, labelMaxSize);
			GridBagConstraints gridBagConstraintsComboMaxSize = new GridBagConstraints();
			gridBagConstraintsComboMaxSize.fill = GridBagConstraints.WEST;
			gridBagConstraintsComboMaxSize.anchor = GridBagConstraints.WEST;
			gridBagConstraintsComboMaxSize.gridx = 1;
			gridBagConstraintsComboMaxSize.gridy = 1;
			gridBagConstraintsComboMaxSize.weightx = 1.0;
			gridBagConstraintsComboMaxSize.insets = new Insets(6, 6, 6, 6);
			m_panelMaxSize.add(getJComboBoxMaxSize(),gridBagConstraintsComboMaxSize);
//			jContentPane.add(getJComboBoxMaxSize(),gridBagConstraintsComboMaxSize);

			m_panelMinSize = new JPanel();
			GridBagConstraints labelMinSize = new GridBagConstraints();
			labelMinSize.gridx = 0;
			labelMinSize.gridy = 2;
			labelMinSize.insets = new Insets(4, 8, 4, 8);
			labelMinSize.anchor = GridBagConstraints.EAST;
			m_lblMinSize = new JLabel();
			m_lblMinSize.setText(IHM.getXmlLangue().getElement("LtailleMinAnnotations")+ " : ");
			m_panelMinSize.add(m_lblMinSize, labelMinSize);
//			jContentPane.add(m_lblMinSize, labelMinSize);
			GridBagConstraints gridBagConstraintsComboMinSize = new GridBagConstraints();
			gridBagConstraintsComboMinSize.fill = GridBagConstraints.WEST;
			gridBagConstraintsComboMinSize.anchor = GridBagConstraints.WEST;
			gridBagConstraintsComboMinSize.gridx = 1;
			gridBagConstraintsComboMinSize.gridy = 2;
			gridBagConstraintsComboMinSize.weightx = 1.0;
			gridBagConstraintsComboMinSize.insets = new Insets(6, 6, 6, 6);
			m_panelMinSize.add(getJComboBoxMinSize(),gridBagConstraintsComboMinSize);
//			jContentPane.add(getJComboBoxMinSize(),gridBagConstraintsComboMinSize);

			m_panelOkAnnuler = new JPanel();
			GridBagConstraints gridBagConstraintsOk = new GridBagConstraints();
			gridBagConstraintsOk.insets = new Insets(8, 8, 8, 8);
			m_panelOkAnnuler.add(getBtOk(), gridBagConstraintsOk);
			m_panelOkAnnuler.setLayout(new GridBagLayout());
			GridBagConstraints gridBagConstraintsAnnuler = new GridBagConstraints();
			gridBagConstraintsAnnuler.insets = new Insets(8, 8, 8, 8);
			m_panelOkAnnuler.add(getBtAnnuler(), gridBagConstraintsAnnuler);

			jContentPane.add(getPanelSize(), null);
			jContentPane.add(getPanelMaxSize(), null);
			jContentPane.add(getPanelMinSize(), null);

			jContentPane.setLayout(new BoxLayout(getJContentPane(),
					BoxLayout.Y_AXIS));
			jContentPane.add(getPanelOkAnnuler(), null);
		}
		return jContentPane;
	}

	private JComboBox getJComboBoxSize() {
		if (JComboBoxSize == null) {
			JComboBoxSize = new JComboBox();
			for (int i = 1; i < 51; i++) {
				JComboBoxSize.addItem(i);
			}
			JComboBoxSize.setSelectedIndex(getTailleAnnotations() - 1);
			JComboBoxSize.addItemListener(new ItemState());
		}
		return JComboBoxSize;
	}

	/**
	 * Classe interne implémentant l'interface ItemListener
	 */
	class ItemState implements ItemListener {

		public void itemStateChanged(ItemEvent e) {
			setTailleAnnotations((Integer) e.getItem());
		}
	}

	private JComboBox getJComboBoxMaxSize() {
		if (JComboBoxMaxSize == null) {
			JComboBoxMaxSize = new JComboBox();
			for (int i = 1; i < 51; i++) {
				JComboBoxMaxSize.addItem(i);
			}
			JComboBoxMaxSize.setSelectedIndex(getTailleMaxAnnotations() - 1);
			JComboBoxMaxSize.addItemListener(new ItemStateMax());
		}
		return JComboBoxMaxSize;
	}

	/**
	 * Classe interne implémentant l'interface ItemListener
	 */
	class ItemStateMax implements ItemListener {

		public void itemStateChanged(ItemEvent e) {
			setTailleMaxAnnotations((Integer) e.getItem());
		}
	}

	private JComboBox getJComboBoxMinSize() {
		if (JComboBoxMinSize == null) {
			JComboBoxMinSize = new JComboBox();
			for (int i = 1; i < 51; i++) {
				JComboBoxMinSize.addItem(i);
			}
			JComboBoxMinSize.setSelectedIndex(getTailleMinAnnotations() - 1);
			JComboBoxMinSize.addItemListener(new ItemStateMin());
		}
		return JComboBoxMinSize;
	}

	/**
	 * Classe interne implémentant l'interface ItemListener
	 */
	class ItemStateMin implements ItemListener {

		public void itemStateChanged(ItemEvent e) {
			setTailleMinAnnotations((Integer) e.getItem());
		}
	}

	/**
	 * This method initializes m_panelSize
	 * 
	 * @return javax.swing.JPanel
	 */
	public JPanel getPanelSize() {
		if (m_panelSize == null) {
			m_panelSize = new JPanel();
			m_panelSize.setLayout(new BorderLayout());
		}
		return m_panelSize;
	}

	/**
	 * This method initializes m_panelMaxSize
	 * 
	 * @return javax.swing.JPanel
	 */
	public JPanel getPanelMaxSize() {
		if (m_panelMaxSize == null) {
			m_panelMaxSize = new JPanel();
			m_panelMaxSize.setLayout(new BorderLayout());
		}
		return m_panelMaxSize;
	}

	/**
	 * This method initializes m_panelMinSize
	 * 
	 * @return javax.swing.JPanel
	 */
	public JPanel getPanelMinSize() {
		if (m_panelMinSize == null) {
			m_panelMinSize = new JPanel();
			m_panelMinSize.setLayout(new BorderLayout());
		}
		return m_panelMinSize;
	}

	/**
	 * This method initializes m_panelOkAnnuler
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getPanelOkAnnuler() {
		if (m_panelOkAnnuler == null) {
			m_panelOkAnnuler = new JPanel();
			m_panelOkAnnuler.setLayout(new BorderLayout());
		}
		return m_panelOkAnnuler;
	}

	/**
	 * This method initializes m_btOk
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtOk() {
		if (m_btOk == null) {
			m_btOk = new JButton();
			m_btOk.setText(IHM.getXmlLangue().getElement("Lok"));
			m_btOk.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					// changement de la taille des annotations
					Variables.setTaillePOLICE_ANNOTATIONS(tailleAnnotations);
					Variables.setTAILLE_MAX_POLICE_ANNOTATIONS(tailleMaxAnnotations);
					Variables.setTAILLE_MIN_POLICE_ANNOTATIONS(tailleMinAnnotations);
					m_gestionnaire.sauverAnnotations();
					m_gestionnaire.updateGraphe();
					getJDialog().dispose();
				}
			});
		}
		return m_btOk;
	}

	/**
	 * This method initializes m_btAnnuler
	 * 
	 * @return javax.swing.JButton
	 */
	private JButton getBtAnnuler() {
		if (m_btAnnuler == null) {
			m_btAnnuler = new JButton();
			m_btAnnuler.setText(IHM.getXmlLangue().getElement("Lannuler"));
			m_btAnnuler.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					getJDialog().dispose();
				};
			});
		}
		return m_btAnnuler;
	}

	protected JDialog getJDialog() {
		return this;
	}
}
