package ihm;

import java.awt.Component;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.HeadlessException;
import java.awt.Insets;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;

import outils.Constantes;
import don.ContinueAnalysee;
import don.DonneeParse;
import don.Nominale;
import don.Qualifiable;
import don.Variable;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class FenetreDescriptionContinue extends JDialog {



	/**
	 * 
	 */
	private static final long serialVersionUID = 2869405279976242619L;

	/**
	 * 
	 */
//	private static final long serialVersionUID = 1L;
	private JPanel jPanel = null;
	
	private JLabel jLabelContinues = null;
	private JScrollPane jScrollPaneContinues = null;
	private JList jListContinues = null;
	private JLabel jLabelNominales = null;
	private JScrollPane jScrollPaneNominales = null;
	private JList jListNominales = null;
	private DonneeParse m_don;
	private Qualifiable m_quali;


	private static HashMap<Qualifiable,FenetreDescriptionContinue> m_fenetres;

	private FenetreDescriptionContinue(Frame arg0, DonneeParse don, Qualifiable qualifiable) throws HeadlessException {
		super(arg0,IHM.getXmlLangue().getElement("LDescription")+qualifiable.getAnnotation());
		m_don=don;
		m_quali=qualifiable;
		initialize();
	}

	/**
	 * @param frame
	 * @param don
	 * @param qualifiable
	 */
	public static void montrer(Frame frame,DonneeParse don, Qualifiable qualifiable) {
		if(m_fenetres==null){
			m_fenetres=new HashMap<Qualifiable, FenetreDescriptionContinue>();
		}
		if(m_fenetres.get(qualifiable)==null || !m_fenetres.get(qualifiable).isVisible()){
			m_fenetres.put(qualifiable,new FenetreDescriptionContinue(frame,don,qualifiable));
		}
//		boolean isProbaCritiqueTropGrande = false;// (qualifiable.getDescCont(cont)<0.05); // ToDoList
//		if (isProbaCritiqueTropGrande) { // proba critique > 0.05
//			m_fenetres.get(qualifiable).setVisible(false);
//		}
//		else { // proba critique < 0.05
			m_fenetres.get(qualifiable).setVisible(true);
//		}
	}	

	/**
	 */
	public static void masquer() {
		if (! (m_fenetres==null)) { //m_fenetres est instancie lors des affichages de fenetres
			Set <Entry<Qualifiable,FenetreDescriptionContinue>> entrees = m_fenetres.entrySet();
			Iterator <Entry<Qualifiable,FenetreDescriptionContinue>> iter = entrees.iterator();
			while(iter.hasNext()) {
				Entry<Qualifiable,FenetreDescriptionContinue> entree = iter.next();
				Qualifiable cle = entree.getKey();
				m_fenetres.get(cle).setVisible(false);
			}
		}
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setContentPane(getJPanel());
		this.pack();	
		this.setResizable(true);
		this.setLocationRelativeTo(null);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel() {
		if (jPanel == null) {
			jLabelNominales = new JLabel();
			jLabelNominales.setText(IHM.getXmlLangue().getElement("LNominale")+" :");
			jLabelContinues = new JLabel();
			jLabelContinues.setText(IHM.getXmlLangue().getElement("LContinue")+" :");
			jPanel = new JPanel();
			jPanel.setLayout(new GridBagLayout());			
			GridBagConstraints gbcpanel = new GridBagConstraints();			 
			gbcpanel.gridx = 0;			
			gbcpanel.gridy = GridBagConstraints.RELATIVE;
			gbcpanel.fill = GridBagConstraints.HORIZONTAL;			 
			gbcpanel.insets = new Insets(0, 15, 15, 15);
			
			GridBagConstraints gbcLabel = new GridBagConstraints();			 
			gbcLabel.gridx = 0;			
			gbcLabel.gridy = GridBagConstraints.RELATIVE;
			gbcLabel.fill = GridBagConstraints.HORIZONTAL;			 
			gbcLabel.insets = new Insets(0, 15, 0, 15);
			
			jPanel.add(jLabelContinues, gbcLabel);
			jPanel.add(getJScrollPaneContinues(), gbcpanel);
			jPanel.add(jLabelNominales, gbcLabel);
			jPanel.add(getJScrollPaneNominales(), gbcpanel);			

		}
		return jPanel;
	}

	/**
	 * This method initializes jScrollPaneContinues	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneContinues() {
		if (jScrollPaneContinues == null) {
			jScrollPaneContinues = new JScrollPane();
			jScrollPaneContinues.setViewportView(getJListContinues());
		}
		return jScrollPaneContinues;
	}

	/**
	 * This method initializes jListContinues	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJListContinues() {
		if (jListContinues == null) {
			jListContinues = new JList();
			SortedSet<Object> vect=new TreeSet<Object>(getComparateur());
			vect.addAll(m_don.getVariablesMoyennes());
			vect.remove(m_quali);
			jListContinues.setListData(vect.toArray());
			jListContinues.setCellRenderer(new DescriptionCellRenderer(m_quali));
		}
		return jListContinues;
	}

	/**
	 * This method initializes jScrollPaneNominales	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPaneNominales() {
		if (jScrollPaneNominales == null) {
			jScrollPaneNominales = new JScrollPane();
			jScrollPaneNominales.setViewportView(getJListNominales());
		}
		return jScrollPaneNominales;
	}

	/**
	 * This method initializes jListNominales	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getJListNominales() {
		if (jListNominales == null) {
			jListNominales = new JList();
			SortedSet<Object> vect=new TreeSet<Object>(getComparateur());
			vect.addAll(m_don.getNominales());
			vect.remove(m_quali);
			jListNominales.setListData(vect.toArray());
			jListNominales.setCellRenderer(new DescriptionCellRenderer(m_quali));
		}
		return jListNominales;
	}

	protected Comparator<Object> getComparateur()
	{
		return new Comparator<Object>()
		{
			public int compare(Object arg0, Object arg1)
			{
				double val=0;
				if(arg0 instanceof Nominale && arg1 instanceof Nominale ){
					val = Math.abs(m_quali.getDescNom((Nominale)arg0)) - Math.abs(m_quali.getDescNom((Nominale)arg1));
				}else if(arg0 instanceof ContinueAnalysee && arg1 instanceof ContinueAnalysee ){
					val = Math.abs(m_quali.getDescCont((ContinueAnalysee)arg0)) - Math.abs(m_quali.getDescCont((ContinueAnalysee)arg1));
				}
				if(arg0.equals(arg1)){
					return 0;
				}else if(val>0){
					return 1;
				}else {
					return -1;
				}
			}
		};
	}

	private class DescriptionCellRenderer implements ListCellRenderer{

		private Qualifiable m_qualiRenderer;

		public DescriptionCellRenderer(Qualifiable quali) {
			m_qualiRenderer=quali;
		}

		public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
			if (value instanceof Nominale) {
				Nominale nom = (Nominale) value;
				return getLabel(nom, m_qualiRenderer.getDescNom(nom));
			}else if (value instanceof ContinueAnalysee) {
				ContinueAnalysee cont = (ContinueAnalysee) value;
				return getLabel(cont, m_qualiRenderer.getDescCont(cont));				
			}else return new JLabel("*error");
		}

		private Component getLabel(Variable var, double val) {
			JLabel label= new JLabel(var.getAnnotation());
			if(val>0 && val<0.05){
				label.setForeground(Constantes.COULEUR_HABILLAGE_CONTINUE_POSITIF);
			}else if(val<0 && val>-0.05){
				label.setForeground(Constantes.COULEUR_HABILLAGE_CONTINUE_NEGATIF);
			}else{
				label.setForeground(Constantes.COULEUR_HABILLAGE_CONTINUE_ZERO);
			}
			return label;
		}
		
	}

}
