package ihm;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintWriter;
import java.io.StringWriter;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.Timer;


/** Fenetre d'affichage des erreurs
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class FenetreErreur implements ActionListener
{	
	private static JTextArea m_textArea;
	private static String m_messages;
	private static int m_count;
	private static Timer m_timer;
	
	/**
	 * @param s
	 */
	public static void display(String s){
		addText(s);
	}
	
	/**
	 * @param e
	 */
	public static void display(Exception e){
		StringWriter writer = new StringWriter();
		e.printStackTrace(new PrintWriter(writer));
		display(writer.toString());
	}
	
	
	/**
	 * @param s
	 */
	public static void addText(String s){
		JTextArea texteArea = getTextArea();
		m_count++;
		m_messages=s+"\n=========================\n"+m_messages;
		texteArea.setText(m_count+" errors:\n==================================================\n"+m_messages);
		m_timer.start();
	}
	
	/**
	 * @return m_textArea
	 */
	public static JTextArea getTextArea(){
		if(m_textArea==null){
			//create and configure a text area - fill it with exception text.
			final JTextArea textArea = new JTextArea();
			textArea.setFont(new Font("Sans-Serif", Font.PLAIN, 10));
			textArea.setEditable(false);
			m_textArea=textArea;
			m_count=0;
			m_messages="";
			m_timer=createTimer();
		}
		return m_textArea;
	}

	
	  private static Timer createTimer ()
	  {
	    // Création d'une instance de listener 
	    // associée au timer
	    ActionListener action = new ActionListener ()
	      {
	        // Méthode appelée à chaque tic du timer
	        public void actionPerformed (ActionEvent event)
	        {
				// stuff it in a scrollpane with a controlled size.
				JScrollPane scrollPane = new JScrollPane(m_textArea);		
				scrollPane.setPreferredSize(new Dimension(375, 500));
				// pass the scrollpane to the joptionpane.	
				String erreur="erreur";
				if(IHM.getXmlLangue()!=null)erreur= IHM.getXmlLangue().getElement("erreur");
				JOptionPane.showMessageDialog(new JFrame(),scrollPane,erreur, JOptionPane.ERROR_MESSAGE);
				m_timer.stop();
				m_count=0;
				m_messages="";
	        }
	      };
	      
	    // Création d'un timer qui génère un tic
	    // chaque 500 millième de seconde
	    return new Timer (500, action);
	  }  

	  
	

	
	
	/** Constructeur  
	 * Crée la fenêtre et y inscrit le message donné
	 * @param s
	 */
	public FenetreErreur(String s)
	{
		//create and configure a text area - fill it with exception text.
		final JTextArea textArea = new JTextArea();
		textArea.setFont(new Font("Sans-Serif", Font.PLAIN, 10));
		textArea.setEditable(false);
		textArea.setText(s);
		// stuff it in a scrollpane with a controlled size.
		JScrollPane scrollPane = new JScrollPane(textArea);		
		scrollPane.setPreferredSize(new Dimension(375, 500));
		// pass the scrollpane to the joptionpane.	
		String erreur="erreur";
		if(IHM.getXmlLangue()!=null)erreur= IHM.getXmlLangue().getElement("erreur");
		JOptionPane.showMessageDialog(new JFrame(),scrollPane,erreur, JOptionPane.ERROR_MESSAGE);
	}
	
	/** Constructeur
	 * Cree la fenetre et y insere la pile de l'exception
	 * @param e
	 */
	public FenetreErreur(Exception e) 
	{	
		// create and configure a text area - fill it with exception text.
		final JTextArea textArea = new JTextArea();
		textArea.setFont(new Font("Sans-Serif", Font.PLAIN, 10));
		textArea.setEditable(false);
		StringWriter writer = new StringWriter();
		e.printStackTrace(new PrintWriter(writer));
		textArea.setText(writer.toString());
		// stuff it in a scrollpane with a controlled size.
		JScrollPane scrollPane = new JScrollPane(textArea);		
		scrollPane.setPreferredSize(new Dimension(375, 150));
		// pass the scrollpane to the joptionpane.	
		String erreur="erreur";
		if(IHM.getXmlLangue()!=null)erreur= IHM.getXmlLangue().getElement("erreur");		
		JOptionPane.showMessageDialog(new JFrame(),scrollPane,erreur , JOptionPane.ERROR_MESSAGE);
	
	}

	public void actionPerformed(ActionEvent arg0) {
		// TODO Auto-generated method stub		
	}
}