package ihm;

import java.awt.BorderLayout;
import javax.swing.JDialog;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.JTextField;
import org.jfree.chart.JFreeChart;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JCheckBox;
import java.awt.Rectangle;
import java.util.Hashtable;

import javax.swing.JSlider;
import javax.swing.BorderFactory;

/** Fenêtre du click droit
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class FenetreProprietes extends JDialog
{
	private static final long serialVersionUID = 1L;

	/** éléments graphique  */
	
	/** conteneur */
	private JPanel m_contentPane = null;

	/** panneau ok-annuler */
	private JPanel m_panelOkAnnuler = null;

	/** sous panneau ok-annuler */
	private JPanel m_panelSSOkAnnuler = null;

	/** panneau contenu */
	private JPanel m_panelContenu = null;

	/** label titre */
	private JLabel m_lblTitre = null;

	/** label X */
	private JLabel m_lblX = null;

	/** label Y */
	private JLabel m_lblY = null;

	/** zone de texte titre */
	private JTextField m_txtTitre = null;

	/** zone de texte X */
	private JTextField m_txtX = null;

	/** zone de texte Y */
	private JTextField m_txtY = null;

	/** bouton ok */
	private JButton m_btOk = null;

	/** bouton annuler */
	private JButton m_btAnnuler = null;

	/** attributs */
	
	/** fen�tre graphique JFreeChart */
	private JFreeChart m_chart;

	/** le Gestionnaire */
	private Gestionnaire m_gestionnaire;

	private JPanel jPanelLegende = null;

	private JLabel jLabelLegende = null;

	private JCheckBox jCheckBoxLegende = null;

	private JPanel jPanelLegendeBouchetrou = null;

	private JSlider jSlider = null;

	private JLabel jLabelRapport = null;

	private JPanel jPanelSlider = null;

	/** This is the default constructor
	 * @param gestionnaire 
	 * @param chart 
	 */
	public FenetreProprietes(Gestionnaire gestionnaire, JFreeChart chart)
	{
		super(gestionnaire.getIHM());
		m_gestionnaire=gestionnaire;
		m_chart=chart;
		initialize();
		setResizable(false);
		setLocationRelativeTo(null);
		setVisible(true);
	}

	/** This method initializes this */
	private void initialize()
	{
		this.setContentPane(getJContentPane());
		this.setTitle(IHM.getXmlLangue().getElement("Tproprietes"));
		this.setBounds(new Rectangle(0, 0, 300, 284));
	}

	/** This method initializes m_contentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane()
	{
		if (m_contentPane == null)
		{
			m_contentPane = new JPanel();
			m_contentPane.setLayout(new BorderLayout());
			m_contentPane.add(getJPanelOkAnnuler(), BorderLayout.SOUTH);
			m_contentPane.add(getJPanelContenu(), BorderLayout.CENTER);
		}
		return m_contentPane;
	}

	/** This method initializes m_panelOkAnnuler	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelOkAnnuler()
	{
		if (m_panelOkAnnuler == null)
		{
			m_panelOkAnnuler = new JPanel();
			m_panelOkAnnuler.setLayout(new BorderLayout());
			m_panelOkAnnuler.add(getJPanelssPanelOkAnnuler(), BorderLayout.EAST);
		}
		return m_panelOkAnnuler;
	}

	/** This method initializes m_panelContenu	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelContenu()
	{
		if (m_panelContenu == null)
		{
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.BOTH;
			gridBagConstraints22.gridx = 1;
			gridBagConstraints22.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints22.gridy = 3;
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.gridx = 0;
			gridBagConstraints12.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints12.gridy = 3;
			jLabelRapport = new JLabel();
			jLabelRapport.setText(IHM.getXmlLangue().getElement("LRapport")+" :");
			GridBagConstraints gridBagConstraints21 = new GridBagConstraints();
			gridBagConstraints21.gridx = 1;
			gridBagConstraints21.fill = GridBagConstraints.NONE;
			gridBagConstraints21.anchor = GridBagConstraints.WEST;
			gridBagConstraints21.gridy = 4;
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.fill = GridBagConstraints.BOTH;
			gridBagConstraints5.gridy = 2;
			gridBagConstraints5.weightx = 1.0;
			gridBagConstraints5.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints5.gridx = 1;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			gridBagConstraints4.gridy = 1;
			gridBagConstraints4.weightx = 1.0;
			gridBagConstraints4.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints4.gridx = 1;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = GridBagConstraints.BOTH;
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints3.gridx = 1;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints2.gridy = 2;
			m_lblY = new JLabel();
			m_lblY.setText(IHM.getXmlLangue().getElement("LaxeY")+" :");
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints1.gridy = 1;
			m_lblX = new JLabel();
			m_lblX.setText(IHM.getXmlLangue().getElement("LaxeX")+" :");
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 0;
			gridBagConstraints.insets = new Insets(8, 8, 8, 8);
			gridBagConstraints.gridy = 0;
			m_lblTitre = new JLabel();
			m_lblTitre.setText(IHM.getXmlLangue().getElement("Ltitre")+" :");
			m_panelContenu = new JPanel();
			m_panelContenu.setLayout(new GridBagLayout());
			m_panelContenu.add(m_lblTitre, gridBagConstraints);
			m_panelContenu.add(m_lblX, gridBagConstraints1);
			m_panelContenu.add(m_lblY, gridBagConstraints2);
			m_panelContenu.add(getJTextFieldTitre(), gridBagConstraints3);
			m_panelContenu.add(getJTextFieldX(), gridBagConstraints4);
			m_panelContenu.add(getJTextFieldY(), gridBagConstraints5);
			m_panelContenu.add(getJPanelLegende(), gridBagConstraints21);
			m_panelContenu.add(getJPanelSlider(), gridBagConstraints22);
			m_panelContenu.add(jLabelRapport, gridBagConstraints12);
		}
		return m_panelContenu;
	}

	/** This method initializes m_txtTitre	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldTitre()
	{
		if (m_txtTitre == null)
		{
			m_txtTitre = new JTextField();
			if(m_chart.getTitle()!=null) m_txtTitre.setText(m_chart.getTitle().getText());
		}
		return m_txtTitre;
	}

	/** This method initializes m_txtX	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldX()
	{
		if (m_txtX == null)
		{
			m_txtX = new JTextField();
			m_txtX.setText(m_chart.getXYPlot().getDomainAxis().getLabel());
		}
		return m_txtX;
	}

	/** This method initializes m_txtY	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJTextFieldY()
	{
		if (m_txtY == null)
		{
			m_txtY = new JTextField();
			m_txtY.setText(m_chart.getXYPlot().getRangeAxis().getLabel());
		}
		return m_txtY;
	}

	/** This method initializes m_panelSSOkAnnuler	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelssPanelOkAnnuler()
	{
		if (m_panelSSOkAnnuler == null)
		{
			GridBagConstraints gridBagConstraints7 = new GridBagConstraints();
			gridBagConstraints7.insets = new Insets(8, 8, 8, 8);
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.insets = new Insets(8, 8, 8, 8);
			m_panelSSOkAnnuler = new JPanel();
			m_panelSSOkAnnuler.setLayout(new GridBagLayout());
			m_panelSSOkAnnuler.add(getJButtonOK(), gridBagConstraints6);
			m_panelSSOkAnnuler.add(getJButtonAnnuler(), gridBagConstraints7);
		}
		return m_panelSSOkAnnuler;
	}

	/** This method initializes m_btOk	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonOK()
	{
		if (m_btOk == null)
		{
			m_btOk = new JButton();
			m_btOk.setText(IHM.getXmlLangue().getElement("Lok"));
			m_btOk.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{
					getGestionnaire().setTitreGraphe(m_txtTitre.getText());
					getGestionnaire().setTitreAxeX(m_txtX.getText());
					getGestionnaire().setTitreAxeY(m_txtY.getText());
					getGestionnaire().setAffLegende(jCheckBoxLegende.isSelected());
					double value = (double)jSlider.getValue()/(double)100;
					getGestionnaire().setRapport(value);
					getGestionnaire().mettreAJourIHM();
					dispose();					
				}
			});
		}
		return m_btOk;
	}

	/** This method initializes m_btAnnuler	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonAnnuler()
	{
		if (m_btAnnuler == null)
		{
			m_btAnnuler = new JButton();
			m_btAnnuler.setText(IHM.getXmlLangue().getElement("Lannuler"));
			m_btAnnuler.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent e)
				{dispose();}
			});
		}
		return m_btAnnuler;
	}

	/**
	 * This method initializes jPanelLegende	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelLegende() {
		if (jPanelLegende == null) {		
			jPanelLegende = new JPanel();
			jPanelLegende.setLayout(new BorderLayout());
			jPanelLegende.add(getJPanelLegendeBouchetrou(), BorderLayout.WEST);
		}
		return jPanelLegende;
	}

	/**
	 * This method initializes jCheckBoxLegende	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBoxLegende() {
		if (jCheckBoxLegende == null) {
			jCheckBoxLegende = new JCheckBox();
			jCheckBoxLegende.setSelected(getGestionnaire().isAffLegende());
		}
		return jCheckBoxLegende;
	}

	/**
	 * This method initializes jPanelLegendeBouchetrou	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelLegendeBouchetrou() {
		if (jPanelLegendeBouchetrou == null) {
			GridBagConstraints gridBagConstraints9 = new GridBagConstraints();
			gridBagConstraints9.gridx = -1;
			gridBagConstraints9.gridy = -1;
			GridBagConstraints gridBagConstraints8 = new GridBagConstraints();
			gridBagConstraints8.anchor = GridBagConstraints.WEST;
			gridBagConstraints8.gridx = -1;
			gridBagConstraints8.gridy = -1;
			gridBagConstraints8.fill = GridBagConstraints.NONE;
			
			jLabelLegende = new JLabel();
			jLabelLegende.setText(IHM.getXmlLangue().getElement("Mlegende")+" : ");
			
			jPanelLegendeBouchetrou = new JPanel();
			jPanelLegendeBouchetrou.setLayout(new GridBagLayout());
			jPanelLegendeBouchetrou.add(jLabelLegende, gridBagConstraints8);
			jPanelLegendeBouchetrou.add(getJCheckBoxLegende(), gridBagConstraints9);
		}
		return jPanelLegendeBouchetrou;
	}

	/**
	 * This method initializes jSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider(0,200,100);
			jSlider.setValue((int)(getGestionnaire().getRapport()*100));
			jSlider.setMajorTickSpacing(100);
			jSlider.setPaintTicks(true);
			
//			Create the label table
			Hashtable<Integer,JLabel> labelTable = new Hashtable<Integer,JLabel>();
			labelTable.put( new Integer( 0 ), new JLabel(IHM.getXmlLangue().getElement("LMoinsLarge")) );
			labelTable.put( new Integer( 200 ), new JLabel(IHM.getXmlLangue().getElement("LPlusLarge")) );
			jSlider.setLabelTable( labelTable );
			jSlider.setPaintLabels(true);
		}
		return jSlider;
	}

	/**
	 * @return
	 */
	private Gestionnaire getGestionnaire() {
		return m_gestionnaire;
	}

	/**
	 * This method initializes jPanelSlider	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelSlider() {
		if (jPanelSlider == null) {
			GridBagConstraints gridBagConstraints10 = new GridBagConstraints();
			gridBagConstraints10.fill = GridBagConstraints.BOTH;
			gridBagConstraints10.gridy = -1;
			gridBagConstraints10.weightx = 1.0;
			gridBagConstraints10.gridx = -1;
			jPanelSlider = new JPanel();
			jPanelSlider.setLayout(new GridBagLayout());
			jPanelSlider.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jPanelSlider.add(getJSlider(), gridBagConstraints10);
		}
		return jPanelSlider;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
