package ihm;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import don.Continue;
import don.Contribution;
import don.Variable;

/**
 *  @author julien.durand@gmail.com
 *
 */
public abstract class PanelHabillage extends JPanel {


	protected static void setComboBox(Variable habillage, List<? extends Variable> liste, JComboBox jComboBox) {
		for (Variable var : liste) {
			jComboBox.addItem(var);
			if(habillage!=null && habillage.equals(var)){
				jComboBox.setSelectedItem(var);
			}
		}
	}

	protected Gestionnaire m_gestionnaire;
	protected Habilleur m_habilleur;

	private static final long serialVersionUID = 1L;
	protected JPanel jPanelDiscret = null;
	protected JPanel jPanelContinu = null;
	protected JCheckBox jCheckBoxContinu = null;
	private JPanel jPanelStyle = null;
	private JLabel jLabelStyle = null;
	private JRadioButton jRadioButtonNuage = null;
	private JRadioButton jRadioButtonBulle = null;
	protected JPanel jPanelType = null;
	protected JRadioButton jRadioButtonCos2 = null;
	protected JRadioButton jRadioButtonContrib = null;
	protected ButtonGroup radioButtonGroupTypes = null;
	protected ButtonGroup radioButtonGroupStyles = null;


	/**
	 * This is the default constructor
	 * @param gestionnaire 
	 */
	public PanelHabillage(Gestionnaire gestionnaire) {
		super();
		m_gestionnaire = gestionnaire;
		m_habilleur = m_gestionnaire.getHabilleur();
	}

	/**
	 * This method initializes this
	 */
	protected void initialize() {
		this.setLayout(new GridBagLayout());
		GridBagConstraints gridBagConstraints =new GridBagConstraints();
		gridBagConstraints.anchor=GridBagConstraints.WEST;
		gridBagConstraints.gridx=0;
		if(m_habilleur.isHabillageNominalePossible())ajouterJPanelDiscret(gridBagConstraints);
		ajouterJPanelContinu(gridBagConstraints);
	}

	protected void ajouterJPanelContinu(GridBagConstraints gridBagConstraints) {
		this.add(getJPanelContinu(),gridBagConstraints);
	}

	protected void ajouterJPanelDiscret(GridBagConstraints gridBagConstraints) {
		this.add(getJPanelDiscret(),gridBagConstraints);
	}


	/**
	 * This method initializes jPanelDiscret	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected abstract JPanel getJPanelDiscret();


	/**
	 * This method initializes jPanelContinu	
	 * 	
	 * @return javax.swing.JPanel	
	 */
// version 1.05_light = version 1.0
//	protected JPanel getJPanelContinu() {
//		if (jPanelContinu == null) {
//			jPanelContinu = new JPanel();
//			jPanelContinu.setLayout(new BorderLayout());
//			jPanelContinu.add(getJCheckBoxContinu(), BorderLayout.NORTH);
//			jPanelContinu.add(getJPanelStyle(), BorderLayout.EAST);
//			jPanelContinu.add(getJPanelType(), BorderLayout.CENTER);
//			setEnabledPanelContinu(jCheckBoxContinu.isSelected());
//		}
//		return jPanelContinu;
//	}
// fin version 1.05_light

// version 1.05_reverse = y'a vraiment une difference ?
    protected JPanel getJPanelContinu()
    {
        if(jPanelContinu == null)
            if(m_gestionnaire.getDon().getType() == don.DonneeParse.TypeAnalyse.PCA && m_gestionnaire.getType() == Gestionnaire.VARIABLES)
            {
                jPanelContinu = new JPanel();
                jPanelContinu.setLayout(new BorderLayout());
                jPanelContinu.add(getJCheckBoxContinu(), "North");
                jPanelContinu.add(getJPanelStyle(), "East");
                jPanelContinu.add(getJPanelType(), "Center");
                setEnabledPanelContinu(jCheckBoxContinu.isSelected());
            } else
            {
                jPanelContinu = new JPanel();
                jPanelContinu.setLayout(new BorderLayout());
                jPanelContinu.add(getJCheckBoxContinu(), "North");
                jPanelContinu.add(getJPanelStyle(), "East");
                jPanelContinu.add(getJPanelType(), "Center");
                setEnabledPanelContinu(jCheckBoxContinu.isSelected());
            }
        return jPanelContinu;
    }
// fin version 1.05_reverse

	/**
	 * This method initializes jCheckBoxContinu	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getJCheckBoxContinu() {
		if (jCheckBoxContinu == null) {
			jCheckBoxContinu = new JCheckBox(IHM.getXmlLangue().getElement("MhabCont")+" : ");
			jCheckBoxContinu.addActionListener(getListener());
			jCheckBoxContinu.setSelected(m_habilleur.getHabillageContinu(getType())!=null);
		}
		return jCheckBoxContinu;
	}


	protected abstract ActionListener getListener();

	/**
	 * This method initializes jPanelStyle	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanelStyle() {
		if (jPanelStyle == null) {
			radioButtonGroupStyles=new ButtonGroup();
			GridBagConstraints gridBagConstraintsBulle = new GridBagConstraints();
			gridBagConstraintsBulle.gridx = 0;
			gridBagConstraintsBulle.gridy = 2;
			gridBagConstraintsBulle.anchor=GridBagConstraints.WEST;
			GridBagConstraints gridBagConstraintsNuage = new GridBagConstraints();
			gridBagConstraintsNuage.gridx = 0;
			gridBagConstraintsNuage.gridy = 1;
			gridBagConstraintsNuage.anchor=GridBagConstraints.WEST;
			GridBagConstraints gridBagConstraintsLabel = new GridBagConstraints();
			gridBagConstraintsLabel.anchor=GridBagConstraints.WEST;
			jLabelStyle = new JLabel();
			jLabelStyle.setText(IHM.getXmlLangue().getElement("MhabStyle")+" :");
			jPanelStyle = new JPanel();
			jPanelStyle.setLayout(new GridBagLayout());
			jPanelStyle.add(jLabelStyle, gridBagConstraintsLabel);
// version 1.05_light
//			if((m_gestionnaire.getDon().getType()==DonneeParse.TypeAnalyse.PCA)&&(m_gestionnaire.getType()==1)){
//				jPanelStyle.add(getJRadioButtonNuage(), gridBagConstraintsNuage);
//			}
//			else{
//				jPanelStyle.add(getJRadioButtonNuage(), gridBagConstraintsNuage);
//				jPanelStyle.add(getJRadioButtonBulle(), gridBagConstraintsBulle);
//			}
// version 1.05_light
			
// version 1.05_reverse = version 1.0
			jPanelStyle.add(getJRadioButtonNuage(), gridBagConstraintsNuage);
			jPanelStyle.add(getJRadioButtonBulle(), gridBagConstraintsBulle);
// fin version 1.05_reverse
		}
		return jPanelStyle;
	}

	/**
	 * This method initializes jRadioButtonNuage	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonNuage() {
		if (jRadioButtonNuage == null) {
			jRadioButtonNuage = new JRadioButton(IHM.getXmlLangue().getElement("MhabNuage"));
			radioButtonGroupStyles.add(jRadioButtonNuage);
			jRadioButtonNuage.setSelected(true);
		}
		return jRadioButtonNuage;
	}

	/**
	 * This method initializes jRadioButtonBulle	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonBulle() {
		if (jRadioButtonBulle == null) {
			jRadioButtonBulle = new JRadioButton(IHM.getXmlLangue().getElement("MhabBulle"));
			radioButtonGroupStyles.add(jRadioButtonBulle);
			jRadioButtonBulle.setSelected(m_habilleur.getHabillageStyleContinu(getType())==Habilleur.STYLE_BULLES);
		}
		return jRadioButtonBulle;
	}

	/**
	 * This method initializes jPanelType	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getJPanelType(){
		if(radioButtonGroupTypes==null){
			radioButtonGroupTypes=new ButtonGroup();
		}
		return getJPanelTypeImpl();
	}

	/**
	 * Constructeur concret du jPanelType
	 * @return javax.swing.JPanel
	 */
	protected abstract JPanel getJPanelTypeImpl();

	/**
	 * This method initializes jRadioButtonCos2	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	protected JRadioButton getJRadioButtonCos2() {
		if (jRadioButtonCos2 == null) {
			jRadioButtonCos2 = new JRadioButton(IHM.getXmlLangue().getElement("Mcos2Habillage"));
			radioButtonGroupTypes.add(jRadioButtonCos2);
			jRadioButtonCos2.setSelected(true);
		}
		return jRadioButtonCos2;
	}

	/**
	 * This method initializes jRadioButtonContrib	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	protected JRadioButton getJRadioButtonContrib() {
		
		if (jRadioButtonContrib == null) {
			jRadioButtonContrib = new JRadioButton(IHM.getXmlLangue().getElement("McontribHabillage"));
			radioButtonGroupTypes.add(jRadioButtonContrib);
			jRadioButtonContrib.setSelected(m_habilleur.getHabillageContinu(getType()) instanceof Contribution);
		}
		return jRadioButtonContrib;
	}

	protected void setEnabledPanelContinu(boolean b) {
		setEnabledPanelStyle(b);
		if(jRadioButtonContrib!=null)jRadioButtonContrib.setEnabled(b);
		if(jRadioButtonCos2!=null)jRadioButtonCos2.setEnabled(b);
	}

	protected void setEnabledPanelStyle(boolean b) {
		jRadioButtonBulle.setEnabled(b);
		jRadioButtonNuage.setEnabled(b);
	}

	/**
	 * @return habillage discret
	 */
	public abstract Variable getHabillageDiscret();

	/**
	 * @return type
	 */
	public abstract int getType();

	/**
	 * @return habillage continue
	 */
	public abstract Continue getHabillageContinu();

	/**
	 * @return style habillage continu
	 */
	public int getStyleHabillageContinu(){
		if(jRadioButtonBulle==null || jRadioButtonNuage==null){
			return -1;
		}
		if(jRadioButtonBulle.isSelected()){
			return Habilleur.STYLE_BULLES;
		}else if(jRadioButtonNuage.isSelected()){
			return Habilleur.STYLE_NUAGE;
		}else
			return -1;
	}

}
