package ihm;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.ListCellRenderer;

import don.Continue;
import don.ContinueAnalysee;
import don.ContinueArtificielleSurAxes;
import don.Contribution;
import don.Cos2;
import don.Dimension;
import don.Nominale;
import don.Variable;

/**
 *  @author julien.durand@gmail.com
 *
 */
// version 1.0
//public class PanelHabillageIndividus extends PanelHabillageModalites {
// fin version 1.0
// version 1.05
public class PanelHabillageIndividus extends PanelHabillage{
// fin version 1.05

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected JCheckBox jCheckBoxNominale;
	protected JComboBox jComboBoxNominale;
	private PanelHabillageIndividusListener m_listener;
// version 1.05
	protected JRadioButton jRadioButtonQuanti;
	protected JComboBox jComboBoxQuanti;
// fin version 1.05



	/**
	 * @param gestionnaire
	 */
	public PanelHabillageIndividus(Gestionnaire gestionnaire) {
		super(gestionnaire);
		initialize();
	}

	@Override
	protected void ajouterJPanelDiscret(GridBagConstraints gridBagConstraints) {
		this.add(getJPanelDiscret(),gridBagConstraints);
	}


	@Override
	protected JPanel getJPanelDiscret()  {
		if (jPanelDiscret == null) {
			GridBagConstraints gridBagConstraintsCheckBox = new GridBagConstraints();
			gridBagConstraintsCheckBox.anchor = GridBagConstraints.WEST;
			gridBagConstraintsCheckBox.gridy=0;
			jPanelDiscret = new JPanel();
			jPanelDiscret.setLayout(new GridBagLayout());
			jPanelDiscret.add(getJCheckBoxNominale(), gridBagConstraintsCheckBox);
			GridBagConstraints gridBagConstraintsCombo = new GridBagConstraints();
			gridBagConstraintsCombo.anchor = GridBagConstraints.WEST;
			gridBagConstraintsCombo.gridy=0;
			jPanelDiscret.add(getJComboBoxNominale(), gridBagConstraintsCombo);
		}
		return jPanelDiscret;
	}


	/**
	 * This method initializes jCheckBoxNominale	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	protected JCheckBox getJCheckBoxNominale() {
		if (jCheckBoxNominale == null) {
			jCheckBoxNominale = new JCheckBox(IHM.getXmlLangue().getElement("Mnominale")+" : ");
// version 1.0
//			jCheckBoxNominale.addActionListener(getListener());
// fin version 1.0
// version 1.05
			jCheckBoxNominale.addActionListener(getListenerI());
// fin version 1.05
			jCheckBoxNominale.setEnabled(m_habilleur.isHabillageIndividusParNominalePossible());
			jCheckBoxNominale.setSelected(m_habilleur.getHabillageDiscret(getType())!=null);
		}
		return jCheckBoxNominale;
	}

	/**
	 * This method initializes jComboBoxNominale	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	protected JComboBox getJComboBoxNominale() {
		if (jComboBoxNominale == null) {
			jComboBoxNominale = new JComboBox();
			jComboBoxNominale.setRenderer(new ListCellRenderer(){
				public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
					if (value instanceof Nominale) {
						Nominale var = (Nominale) value;
						return new JLabel(var.getAnnotation());						
					}else{
						return new JLabel("*error");
					}
				}

			});

			setComboBox(m_habilleur.getHabillageDiscret(getType()), m_habilleur.getHabillageParNominalePossible(getType()), jComboBoxNominale);
		}
		jComboBoxNominale.setEnabled(jCheckBoxNominale.isSelected());
		return jComboBoxNominale;
	}




	@Override
	public Variable getHabillageDiscret() {
		if(getJCheckBoxNominale().isSelected()){
			Object selection =jComboBoxNominale.getSelectedItem();
			if (selection instanceof Variable) {
				Variable var = (Variable) selection;
				return var;
			}else
				return null;
		}else
			return null;
	}


	@Override
	public int getType() {
		return Habilleur.INDIVIDUS;
	}

// version 1.0	
//	protected ActionListener getListener(){
// fin version 1.0
// version 1.05
	protected ActionListener getListenerI(){
// fin version 1.05
		if(m_listener==null){
			m_listener = new PanelHabillageIndividusListener();
		}
		return m_listener;
	}

	private class PanelHabillageIndividusListener implements ActionListener{

		public void actionPerformed(ActionEvent e) {
			Object source = e.getSource();	
			if(source.equals(jCheckBoxNominale)){
				jComboBoxNominale.setEnabled(jCheckBoxNominale.isSelected());
			}else if(source.equals(jRadioButtonQuanti)){
				jComboBoxQuanti.setEnabled(jRadioButtonQuanti.isSelected());
			}else if(source.equals(jCheckBoxContinu)){
				setEnabledPanelContinu(jCheckBoxContinu.isSelected());
			}
		}

	}

	protected void setEnabledPanelContinu(boolean b) {
		super.setEnabledPanelContinu(b);
		if(jRadioButtonQuanti!=null)jRadioButtonQuanti.setEnabled(b);
		if(jComboBoxQuanti!=null)
			if(b){
				jComboBoxQuanti.setEnabled(jRadioButtonQuanti.isSelected());
			}else{
				jComboBoxQuanti.setEnabled(false);
			}

	}

// version 1.05


@Override
	public Continue getHabillageContinu() {
		if(jCheckBoxContinu.isSelected()){
			if(getJRadioButtonQuanti().isSelected()){
				Object selection = jComboBoxQuanti.getSelectedItem();
				if (selection instanceof ContinueAnalysee) {
					ContinueAnalysee cont = (ContinueAnalysee) selection;
					return cont;
				}else
					return null;
			}else if(m_gestionnaire.getType()==Gestionnaire.INDIVIDUS){
				if(getJRadioButtonContrib().isSelected()){
					return new Contribution(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
				}else if(getJRadioButtonCos2().isSelected()){
					return new Cos2(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
				}else return null;
			}
			else 
				return null;
		}else
			return null;
	}

	

	@Override
	protected JPanel getJPanelTypeImpl() {
		if (jPanelType == null) {
			jPanelType = new JPanel();
			jPanelType.setLayout(new GridBagLayout());
			if(m_gestionnaire.getType()==Gestionnaire.INDIVIDUS){
				GridBagConstraints gridBagConstraintsContrib = new GridBagConstraints();
				gridBagConstraintsContrib.anchor=GridBagConstraints.WEST;
				gridBagConstraintsContrib.insets = new Insets(0, 10, 0, 0);
				gridBagConstraintsContrib.gridy = 1;
				gridBagConstraintsContrib.gridx = 0;
				GridBagConstraints gridBagConstraintsCos2 = new GridBagConstraints();
				gridBagConstraintsCos2.anchor=GridBagConstraints.WEST;
				gridBagConstraintsCos2.insets = new Insets(0, 10, 0, 0);
				gridBagConstraintsCos2.gridy = 0;
				gridBagConstraintsCos2.gridx = 0;
				jPanelType.add(getJRadioButtonCos2(), gridBagConstraintsCos2);
				jPanelType.add(getJRadioButtonContrib(), gridBagConstraintsContrib);
								
			}
			if(m_habilleur.isHabillageContinuePossible()){
				GridBagConstraints gridBagConstraintsComboQuanti = new GridBagConstraints();
				gridBagConstraintsComboQuanti.fill = GridBagConstraints.BOTH;
				gridBagConstraintsComboQuanti.anchor=GridBagConstraints.WEST;
				gridBagConstraintsComboQuanti.gridx = 2;
				gridBagConstraintsComboQuanti.gridy = 2;
				gridBagConstraintsComboQuanti.weightx = 1.0;
				gridBagConstraintsComboQuanti.insets = new Insets(6, 6, 6, 6);
				GridBagConstraints gridBagConstraintsButtonQuanti = new GridBagConstraints();
				gridBagConstraintsButtonQuanti.anchor=GridBagConstraints.WEST;
				gridBagConstraintsButtonQuanti.insets = new Insets(0, 10, 0, 0);
				gridBagConstraintsButtonQuanti.gridy = 2;
				gridBagConstraintsButtonQuanti.gridx = 0;
				jPanelType.add(getJRadioButtonQuanti(), gridBagConstraintsButtonQuanti);
				jPanelType.add(getJComboBoxQuanti(), gridBagConstraintsComboQuanti);
			}
		}
		return jPanelType;
	}

	/**
	 * This method initializes jRadioButtonQuanti	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonQuanti() {
		if (jRadioButtonQuanti == null) {
			jRadioButtonQuanti = new JRadioButton(IHM.getXmlLangue().getElement("MhabZ")+" : ");
			radioButtonGroupTypes.add(jRadioButtonQuanti);
			jRadioButtonQuanti.addActionListener(getListener());
			Continue habillageContinu = m_habilleur.getHabillageContinu(getType());
			jRadioButtonQuanti.setSelected(!(habillageContinu==null || habillageContinu instanceof ContinueArtificielleSurAxes));
		}
		return jRadioButtonQuanti;
	}

	/**
	 * This method initializes jComboBoxQuanti	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxQuanti() {

		if (jComboBoxQuanti == null) {
			jComboBoxQuanti = new JComboBox();
			jComboBoxQuanti.setRenderer(new ListCellRenderer(){
				public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
					if (value instanceof ContinueAnalysee) {
						ContinueAnalysee var = (ContinueAnalysee) value;
						return new JLabel(var.getAnnotation());						
					}else{
						return new JLabel("*error");
					}
				}				
			});
			setComboBox(m_habilleur.getHabillageContinu(getType()),m_habilleur.getHabillageParContinuesPossible(getType()), jComboBoxQuanti);
		}
		jComboBoxQuanti.setEnabled(getJRadioButtonQuanti().isSelected());
		return jComboBoxQuanti;
	}

	/*	private JRadioButton getJRadioButtonVTest() {
		if (jRadioButtonVTest == null) {
			jRadioButtonVTest = new JRadioButton(IHM.getXmlLangue().getElement("MhabVTest"));
			radioButtonGroupTypes.add(jRadioButtonVTest);
			jRadioButtonVTest.addActionListener(getListener());
			jRadioButtonVTest.setSelected(m_habilleur.getHabillageContinu(getType()) instanceof ValeurTest);
		}
		return jRadioButtonVTest;
	}
	 */
	

	@Override
	protected ActionListener getListener() {
		return new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				Object source=e.getSource();
				if(source.equals(jCheckBoxContinu)){
					setEnabledPanelContinu(jCheckBoxContinu.isSelected());
				}else if(source.equals(jRadioButtonQuanti)){
					jComboBoxQuanti.setEnabled(jRadioButtonQuanti.isSelected());
				}
			}

		};
	}

// fin version 1.05	

	
}
