package ihm;

import java.awt.Component;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.ListCellRenderer;

import don.Continue;
import don.ContinueAnalysee;
import don.ContinueArtificielleSurAxes;
import don.Contribution;
import don.Cos2;
import don.Dimension;
import don.Variable;


/**
 *  @author julien.durand@gmail.com
 *
 */
public class PanelHabillageModalites extends PanelHabillage{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	protected JRadioButton jRadioButtonQuanti;
	protected JComboBox jComboBoxQuanti;

	/**
	 * @param gestionnaire
	 */
	public PanelHabillageModalites(Gestionnaire gestionnaire) {
		super(gestionnaire);
		initialize();
	}

	@Override
	public Continue getHabillageContinu() {
		if(jCheckBoxContinu.isSelected()){
			if(getJRadioButtonQuanti().isSelected()){
				Object selection = jComboBoxQuanti.getSelectedItem();
				if (selection instanceof ContinueAnalysee) {
					ContinueAnalysee cont = (ContinueAnalysee) selection;
					return cont;
				}else
					return null;
			}else if(m_gestionnaire.getType()==Gestionnaire.INDIVIDUS){
				if(getJRadioButtonContrib().isSelected()){
					return new Contribution(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
				}else if(getJRadioButtonCos2().isSelected()){
					return new Cos2(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
				}else return null;
			}
			else 
				return null;
		}else
			return null;
	}

	@Override
	public Variable getHabillageDiscret() {
		return null;
	}

	@Override
	protected JPanel getJPanelDiscret() {
		return null;
	}

	@Override
	protected JPanel getJPanelTypeImpl() {
		if (jPanelType == null) {
			jPanelType = new JPanel();
			jPanelType.setLayout(new GridBagLayout());
			if(m_gestionnaire.getType()==Gestionnaire.INDIVIDUS){		
// version 1.05_reverse	
				if(m_habilleur.getTypeAnalyse() != don.DonneeParse.TypeAnalyse.PCA)
					{
// fin version 1.05_reverse	
						GridBagConstraints gridBagConstraintsContrib = new GridBagConstraints();
						gridBagConstraintsContrib.anchor = GridBagConstraints.WEST;
						gridBagConstraintsContrib.insets = new Insets(0, 10, 0, 0);
						gridBagConstraintsContrib.gridy = 1;
						gridBagConstraintsContrib.gridx = 0;
// version 1.05_reverse
						jPanelType.add(getJRadioButtonContrib(), gridBagConstraintsContrib);
					}
// fin version 1.05_reverse	
				GridBagConstraints gridBagConstraintsCos2 = new GridBagConstraints();
				gridBagConstraintsCos2.anchor=GridBagConstraints.WEST;
				gridBagConstraintsCos2.insets = new Insets(0, 10, 0, 0);
				gridBagConstraintsCos2.gridy = 0;
				gridBagConstraintsCos2.gridx = 0;
				jPanelType.add(getJRadioButtonCos2(), gridBagConstraintsCos2);
// version 1.05_light
//				jPanelType.add(getJRadioButtonContrib(), gridBagConstraintsContrib);
// fin version 1.05_light				
			}
// version 1.05_light
//			if(m_habilleur.isHabillageContinuePossible()){
// fin version 1.05_light
// version 1.05_reverse
    		if(m_habilleur.isHabillageContinuePossible() && m_habilleur.getTypeAnalyse() != don.DonneeParse.TypeAnalyse.PCA) {	
// fin version 1.05_reverse	
				GridBagConstraints gridBagConstraintsComboQuanti = new GridBagConstraints();
				gridBagConstraintsComboQuanti.fill = GridBagConstraints.BOTH;
				gridBagConstraintsComboQuanti.anchor=GridBagConstraints.WEST;
				gridBagConstraintsComboQuanti.gridx = 2;
				gridBagConstraintsComboQuanti.gridy = 2;
				gridBagConstraintsComboQuanti.weightx = 1.0;
				gridBagConstraintsComboQuanti.insets = new Insets(6, 6, 6, 6);
				GridBagConstraints gridBagConstraintsButtonQuanti = new GridBagConstraints();
				gridBagConstraintsButtonQuanti.anchor=GridBagConstraints.WEST;
				gridBagConstraintsButtonQuanti.insets = new Insets(0, 10, 0, 0);
				gridBagConstraintsButtonQuanti.gridy = 2;
				gridBagConstraintsButtonQuanti.gridx = 0;
				jPanelType.add(getJRadioButtonQuanti(), gridBagConstraintsButtonQuanti);
				jPanelType.add(getJComboBoxQuanti(), gridBagConstraintsComboQuanti);
			}
// version 1.05_light
//			if((m_habilleur.getTypeAnalyse())==(DonneeParse.TypeAnalyse.PCA)){
//				jRadioButtonContrib.setEnabled(false);
//				jRadioButtonQuanti.setEnabled(false);
//			}
// fin version 1.05_light
		}
		return jPanelType;
	}	

	/**
	 * This method initializes jRadioButtonQuanti	
	 * 	
	 * @return javax.swing.JRadioButton	
	 */
	private JRadioButton getJRadioButtonQuanti() {
		if (jRadioButtonQuanti == null) {
			jRadioButtonQuanti = new JRadioButton(IHM.getXmlLangue().getElement("MhabZ")+" : ");
			radioButtonGroupTypes.add(jRadioButtonQuanti);
			jRadioButtonQuanti.addActionListener(getListener());
			Continue habillageContinu = m_habilleur.getHabillageContinu(getType());
			jRadioButtonQuanti.setSelected(!(habillageContinu==null || habillageContinu instanceof ContinueArtificielleSurAxes));
		}
		return jRadioButtonQuanti;
	}

	/**
	 * This method initializes jComboBoxQuanti	
	 * 	
	 * @return javax.swing.JComboBox	
	 */
	private JComboBox getJComboBoxQuanti() {

		if (jComboBoxQuanti == null) {
			jComboBoxQuanti = new JComboBox();
			jComboBoxQuanti.setRenderer(new ListCellRenderer(){
				public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
					if (value instanceof ContinueAnalysee) {
						ContinueAnalysee var = (ContinueAnalysee) value;
						return new JLabel(var.getAnnotation());						
					}else{
						return new JLabel("*error");
					}
				}				
			});
			setComboBox(m_habilleur.getHabillageContinu(getType()),m_habilleur.getHabillageParContinuesPossible(getType()), jComboBoxQuanti);
		}
		jComboBoxQuanti.setEnabled(getJRadioButtonQuanti().isSelected());
		return jComboBoxQuanti;
	}

	/*	private JRadioButton getJRadioButtonVTest() {
		if (jRadioButtonVTest == null) {
			jRadioButtonVTest = new JRadioButton(IHM.getXmlLangue().getElement("MhabVTest"));
			radioButtonGroupTypes.add(jRadioButtonVTest);
			jRadioButtonVTest.addActionListener(getListener());
			jRadioButtonVTest.setSelected(m_habilleur.getHabillageContinu(getType()) instanceof ValeurTest);
		}
		return jRadioButtonVTest;
	}
	 */
	protected void ajouterJPanelDiscret(GridBagConstraints gridBagConstraintsJPanelDiscret) {

	}

	@Override
	protected ActionListener getListener() {
		return new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				Object source=e.getSource();
				if(source.equals(jCheckBoxContinu)){
					setEnabledPanelContinu(jCheckBoxContinu.isSelected());
				}else if(source.equals(jRadioButtonQuanti)){
					jComboBoxQuanti.setEnabled(jRadioButtonQuanti.isSelected());
				}
			}

		};
	}

	@Override
	public int getType() {
		return Habilleur.MODALITES;
	}

	protected void setEnabledPanelContinu(boolean b) {
		super.setEnabledPanelContinu(b);
		if(jRadioButtonQuanti!=null)jRadioButtonQuanti.setEnabled(b);
		if(jComboBoxQuanti!=null)
			if(b){
				jComboBoxQuanti.setEnabled(jRadioButtonQuanti.isSelected());
			}else{
				jComboBoxQuanti.setEnabled(false);
			}			
	}
}
