package ihm;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JPanel;

import don.Continue;
import don.Contribution;
import don.Cos2;
import don.Dimension;
import don.DonneeParse;
import don.Variable;

/**
 *  @author julien.durand@gmail.com
 *
 */
public class PanelHabillageVariables extends PanelHabillage {

	/**
	 * 
	 */
	private static final long serialVersionUID = -5187882059225812158L;
	private JCheckBox jCheckBoxGroupe;
	private int m_type;

	/**
	 * @param gestionnaire
	 * @param type
	 */
	public PanelHabillageVariables(Gestionnaire gestionnaire, int type) {
		super(gestionnaire);
		m_type=type;
		initialize();
	}

	@Override
	public Continue getHabillageContinu() {

		if(jCheckBoxContinu.isSelected()){
			if(jRadioButtonCos2!=null && jRadioButtonCos2.isSelected()){
				return  new Cos2(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
			}else if(jRadioButtonContrib.isSelected()){
				return  new Contribution(((Dimension)m_gestionnaire.getAxeX()),((Dimension)m_gestionnaire.getAxeY()));
			}else
				return null;
		}else return null;
	}

	@Override
	public Variable getHabillageDiscret() {
		if(jCheckBoxGroupe.isSelected()){
			return m_habilleur.getHabillageGroupe();
		}else
			return null;
	}

	@Override
// version 1.05_light
//	protected JPanel getJPanelDiscret() {
//		if((m_gestionnaire.getDon().getType()!=DonneeParse.TypeAnalyse.PCA)){
//		if (jPanelDiscret == null) {
//			GridBagConstraints gridBagConstraintsCheckBox = new GridBagConstraints();
//			gridBagConstraintsCheckBox.anchor = GridBagConstraints.WEST;
//			gridBagConstraintsCheckBox.fill=GridBagConstraints.HORIZONTAL;
//			jPanelDiscret = new JPanel();
//			jPanelDiscret.setLayout(new GridBagLayout());
//			jPanelDiscret.add(getJCheckBoxGroupe(), gridBagConstraintsCheckBox);
//
//		}
//	}
//		return jPanelDiscret;
//	}
// fin version 1.05_light

// version 1.05_reverse
	protected JPanel getJPanelDiscret()
    {
        if(jPanelDiscret == null)
        {
            GridBagConstraints gridBagConstraintsCheckBox = new GridBagConstraints();
            gridBagConstraintsCheckBox.anchor = GridBagConstraints.WEST;
            gridBagConstraintsCheckBox.fill = GridBagConstraints.HORIZONTAL;
            jPanelDiscret = new JPanel();
            jPanelDiscret.setLayout(new GridBagLayout());
            if(m_gestionnaire.getDon().getType() != don.DonneeParse.TypeAnalyse.PCA)
                jPanelDiscret.add(getJCheckBoxGroupe(), gridBagConstraintsCheckBox);
        }
        return jPanelDiscret;
    }
// fin version 1.05_reverse

	private JCheckBox getJCheckBoxGroupe() {
		if (jCheckBoxGroupe == null) {
			jCheckBoxGroupe = new JCheckBox(IHM.getXmlLangue().getElement("MgroupeHabillage"));
			jCheckBoxGroupe.addActionListener(getListener());
			jCheckBoxGroupe.setSelected(m_habilleur.getHabillageDiscret(getType())!=null);
			jCheckBoxGroupe.setEnabled(m_gestionnaire.getDon().getType()==DonneeParse.TypeAnalyse.MFA);
		}
		return jCheckBoxGroupe;
	}

	@Override
	protected JPanel getJPanelTypeImpl() {
		if (jPanelType == null) {
			GridBagConstraints gridBagConstraintsCos2 = new GridBagConstraints();
			gridBagConstraintsCos2.anchor=GridBagConstraints.WEST;
			gridBagConstraintsCos2.insets = new Insets(0, 10, 0, 0);
			gridBagConstraintsCos2.gridy = 0;
			gridBagConstraintsCos2.gridx = 0;
			GridBagConstraints gridBagConstraintsContrib = new GridBagConstraints();
			gridBagConstraintsContrib.anchor=GridBagConstraints.WEST;
			gridBagConstraintsContrib.insets = new Insets(0, 10, 0, 0);
			gridBagConstraintsContrib.gridy = 2;
			gridBagConstraintsContrib.gridx = 0;
			jPanelType = new JPanel();
			jPanelType.setLayout(new GridBagLayout());
			if(m_habilleur.isHabillageCos2Possible(m_type))
				jPanelType.add(getJRadioButtonCos2(), gridBagConstraintsCos2);
			if(m_habilleur.isHabillageContribPossible(m_type))					
				jPanelType.add(getJRadioButtonContrib(), gridBagConstraintsContrib);
			if(m_type==Habilleur.AXES_PARTIELS)
				jRadioButtonContrib.setSelected(true);
		}
		return jPanelType;
	}

	@Override
	protected ActionListener getListener() {
		return new ActionListener(){

			public void actionPerformed(ActionEvent e) {
				Object source=e.getSource();
				if(source.equals(jCheckBoxContinu)){
					setEnabledPanelContinu(jCheckBoxContinu.isSelected());
				}
			}

		};
	}

	@Override
	public int getType() {
		return m_type;
	}

	protected void setEnabledPanelContinu(boolean b) {
		super.setEnabledPanelContinu(b);	
		setEnabledPanelStyle(false);
	}
}
