package org.jfree.chart.plot;

import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.io.Serializable;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.plot.PlotRenderingInfo;
import org.jfree.chart.plot.PlotState;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYItemRenderer;
import org.jfree.data.Range;
import org.jfree.data.xy.XYDataset;

/** Classe qui creer le graphe des groupes
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class GroupPlot extends XYPlot implements Cloneable, Serializable
{
    private static final long serialVersionUID = -477525209363105945L;

    /**
     * @param dataset
     * @param axis
     * @param axis2
     * @param renderer
     */
    public GroupPlot(XYDataset dataset, NumberAxis axis, NumberAxis axis2, XYItemRenderer renderer)
    {super(dataset, axis, axis2, renderer);}

	public void draw(Graphics2D g2, Rectangle2D area, Point2D anchor, PlotState parentState, PlotRenderingInfo info)
	{
		draw(g2, area, anchor, parentState, info, 1);
	}

	public void draw(Graphics2D g2, Rectangle2D area, Point2D anchor, PlotState parentState, PlotRenderingInfo info, double rapport)
	{		
		ValueAxis horizontalAxis = getDomainAxis();
		ValueAxis verticalAxis = getRangeAxis();
		verticalAxis.setRange(new Range(-0.1, 1.1), false, false);
		horizontalAxis.setRange(new Range(-0.1, 1.1), false, false);
		super.draw(g2, area, anchor, parentState, info, rapport);
    }
}