package org.jfree.chart.plot;

import java.awt.Color;
import java.awt.Paint;

import org.jfree.chart.renderer.RendererState;

public class VecPlotState extends RendererState {
	private Paint DEFAULT_PAINT = Color.white;

	private double m_x;

	private double m_y;

	private double m_rayon;

	private Paint m_cercle;

	public VecPlotState(PlotRenderingInfo info) {
		super(info);
		setX(0);
		setY(0);
		setRayon(0);
		setCercle(DEFAULT_PAINT);
	}

	public VecPlotState(PlotRenderingInfo info, double x, double y, double rayon) {
		super(info);
		setX(x);
		setY(y);
		setRayon(rayon);
		setCercle(DEFAULT_PAINT);
	}

	public VecPlotState(PlotRenderingInfo info, double x, double y,
			double rayon, Paint cercle) {
		super(info);
		setX(x);
		setY(y);
		setRayon(rayon);
		setCercle(cercle);
	}

	public double getX() {
		return m_x;
	}

	public void setX(double x) {
		m_x = x;
	}

	public double getY() {
		return m_y;
	}

	public void setY(double y) {
		m_y = y;
	}

	public double getRayon() {
		return m_rayon;
	}

	public void setRayon(double rayon) {
		m_rayon = rayon;
	}

	public Paint getCercle() {
		return m_cercle;
	}

	public void setCercle(Paint cercle) {
		m_cercle = cercle;
	}
}
