package outils;

import ihm.FenetreErreur;
import ihm.IHM;

import javax.swing.JOptionPane;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import javax.swing.JFrame;

import drawing.Registre;

/**
 * classe qui propose des fonctions d'accés aux fichiers
 * 
 *  @author michaelory@gmail.com
 *  @author julien.durand.eu@gmail.com
 *
 */
public class Fichier {

	/**
	 * Charge un {@link Registre} depuis le fichier dont le chemin 
	 * est passé en paramêtre
	 * @param chemin
	 * @return l'objet de sauvegarde
	 */
	public static Registre chargerDonnees(String chemin) {
		Registre d=null;
		try {			
			File serial = new File(chemin);
			FileInputStream fis = new FileInputStream(serial);
			ObjectInputStream ois = new ObjectInputStream(fis);
			d = (Registre)ois.readObject();
			ois.close();
			fis.close();
		}
		catch (InvalidClassException e)
		{
			JOptionPane.showMessageDialog(new JFrame(),IHM.getXmlLangue().getElement("version_fichier_incompatible"), IHM.getXmlLangue().getElement("erreur"),JOptionPane.ERROR_MESSAGE);
		}
		catch (Exception e)
		{
			new FenetreErreur(e);
		}
		return d;
	}

	/**
	 * S�rialise un {@link Registre} dans un fichier  
	 * @param d : le registre à sauver
	 * @param chemin 
	 */
	public static void serialiser(Registre d, String chemin){
		try {
			File serial = new File(chemin);
			FileOutputStream fos = new FileOutputStream(serial);
			ObjectOutputStream oos = new ObjectOutputStream(fos);
			oos.writeObject(d);
			oos.flush();
			oos.close();
			fos.close();
		}
		catch (IOException ioe)
		{
			new FenetreErreur(ioe);
		}
	}
}
